      SUBROUTINE GRAB(S,I4OR8,IBASE,NWORDS)                             MAN   20
      REAL*8 S
      DIMENSION S(1)                                                    MAN   30
C                                                                       MAN   40
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - MAN   50
C                                                                       MAN   60
C      THIS ROUTINE WILL OBTAIN ALL CORE REQUESTED ON THE JOB CARD      MAN   70
C   FOR USE IN A ONE-DIMENSIONAL ARRAY  'S'.... S(IBASE) IS THE FIRST   MAN   80
C   WORD OF THE ALLOCATED CORE.                                         MAN   90
C                                                                       MAN  100
C  ::;  DESCRIPTION OF PARAMETERS                                       MAN  110
C    S    -   THE ARRAY RELATIVE TO WHICH 'GRABBED' CORE IS ADDRESSED   MAN  120
C  I4OR8  -   AN I*4 VARIABLE WHOSE VALUE IS THE NUMBER OF BYTES PER    MAN  130
C             WORD IN THE ARRAY 'S'.  1,2,4,8,16 AND 32 ARE VALID       MAN  140
C  IBASE  -   THE INDEX OF THE FIRST WORD OF THE 'GRABBED' CORE         MAN  150
C  NWORDS -   THE NUMBER OF I4OR8-BYTE WORDS ALLOCATED                  MAN  160
C     ON INPUT IT IS THE NUMBER OF BYTES TO ALLOCATE, OR IF NEGATIVE,   MAN  170
C     IT IS THE NUMBER OF BYTES TO LEAVE FREE.                          MAN  180
CDCC                                                                    MAN  190
CDCC     I4OR8 = 1 IS REQUIRED                                          MAN  200
CDCC     NWORDS - ON INPUT IS THE NUMBER OF WORDS TO ALLOCATE.  IF      MAN  210
CDCC              NEGATIVE, 10000 IS USED.                              MAN  220
CDCC                                                                    MAN  230
C                                                                       MAN  240
C     IF FEWER THAN 16K WORDS ARE AVAILABLE, THE ROUTINE STOPS          MAN  250
C                                                                       MAN  260
C  THIS ROUTINE USES STEVE PIEPER'S ROUTINE KORUSE...                   MAN  270
C        IGOT=KORUSE(IASK,ITSAT)                                        MAN  280
C  FOUND IN B21541.GENLIB.LOAD.  SOURCE IS IN B21541.GENLIB.FORT ON     MAN  290
C  CELLBC.   KORUSE TRIES TO ALLOCATE IASK BYTES OF CORE. IT RETURNS    MAN  300
C  IGOT BYTES OF CORE. THIS IS SMALLER THAN IASK IF IASK CONTIGUOUS     MAN  310
C  BYTES NOT AVAILABLE                                                  MAN  320
C  ITSAT IS THE ABSOLUTE LOCATION IN CORE OF THE FIRST BTYE             MAN  330
C  THIS ROUTINE ALSO USES STEVE PIEPER'S  ROUTINE KORFRE                MAN  340
C  WHICH HAS A DUMMY ARGUMENT AND RETURNS THE AVAILABLE CORE            MAN  350
C  IN BYTES                                                             MAN  360
C                                                                       MAN  510
C  IF SIZE GIVEN IN INPUT WILL ASK FOR THE AMOUNT SPECIFIED             MAN  520
C  ALSO WILL CHECK IF AVAILABLE                                         MAN  530
C                                                                       MAN 1940
C     FOLLOWING IS FOR UNIX(ULTRIX) (VIRTUAL MEMORY)   
C                                                                       MAN 1960
      IASK = NWORDS
      IF ( IASK .LT. 0 ) IASK = 5 000 000                               MAN 1980
      CALL GET_MEMORY(IASK,ITSAT,IERR)
      if(itsat.eq.0)then
          write(*,*)'FATAL ERROR: cannot fill memory request'
          call exit(1)
      endif
CVAX  IRET = LIB$GET_VM ( IASK, ITSAT )                                 MAN 1990
CVAX  IF ( IRET .NE. 1 ) CALL LIB$STOP (%VAL(IRET) )                    MAN 2000
      PRINT 1003, IASK                                                  MAN 2010
 1003 FORMAT ( ' ALLOCATED ', I10, ' BYTES OF VIRTUAL MEMORY' / )       MAN 2020
      NWORDS = IASK/I4OR8 - 1                                           MAN 2030
C                                                                       MAN 2060
C   HERE WE HAVE IGOT BYTES STARTING IN LOCATION ITSAT                  MAN 2070
C                                                                       MAN 2080
C   <-------------- ITSAT BYTES ---------> <---- IGOT BYTES ----->      MAN 2090
C                                                                       MAN 2100
C  0                S(1)                S(IBASE)        S(IBASE+NWORDS) MAN 2110
C   <-LOCF(S) BYTES->                                                   MAN 2120
C                                                                       MAN 2130
C -- THE LOCF FUNCTION RETURNS THE ADDRESS (IN BYTES REL TO LOC'N 0)    MAN 2140
C   OF THE VARIABLE S                                                   MAN 2150
C                                                                       MAN 2160
  60  LOCS = %LOC(S)                                                    MAN 2170
      IBASE = (ITSAT-LOCS)/I4OR8 + 1                                    MAN 2180
      nelem=iask/i4or8
      do i=1,nelem
         s(ibase+i)=0.
      enddo
COMC                                                                    MAN 2240
COMC      FOR FIXED-SIZE COMMON MEMORY                                  MAN 2250
COMC                                                                    MAN 2260
COM      IBASE = 10                                                     MAN 2270
COM      NWORDS = MAXWRD - IBASE                                        MAN 2280
COM      PRINT 23, NWORDS                                               MAN 2290
COM  23  FORMAT ( '0FIXED COMMON BLOCK VERSION OF PTOLEMY, ',           MAN 2300
COM     1  ' ALLOCATOR SIZE =', I6, ' WORDS.' / )                       MAN 2310
      RETURN                                                            MAN 2320
      END
      
      SUBROUTINE GETLNK ( AKEY, IRET )                                  MAN   20
C                                                                       MAN   30
C     PROCESSES LINKULE KEYWORDS AND LOADS LINKULE                      MAN   40
C                                                                       MAN   50
C     THIS ROUTINE DETERMINES WHAT ( REAL POTENTIAL, IMAG POTENTIAL,    MAN   60
C     WAVE FUNCTIONS) IS TO BE SET BY THE LINKULE AND ALSO THE          MAN   70
C     LINKULE NAME.                                                     MAN   80
C     IT THEN LOADS THE LINKULE AND SAVES ITS ADDRESS.                  MAN   90
C                                                                       MAN  100
C     IRET - 0 = AN ERROR; 1 = O.K.                                     MAN  110
C                                                                       MAN  120
C     11/24/77 - FIRST VERSION - S.P.                                   MAN  130
C     7/6/78 - CDC VERSION ADDED                                        MAN  140
C     12/7/78 - TENSOR POTENTIALS ADDED, AND USE NUMLNK - RPG           MAN  150
C     12/27/79 - CHANGE CDC PREFIXES TO CNI, ADD MORE NAMES - RPG       MAN  160
C     1/16/80 - MORE CHARACTER*8'S, REMOVE EXTRA / - RPG                MAN  170
C      1/21/80 - %M, CIB%F AROUND LOCF CALLS - RPG                      MAN  180
C     2/25/80 - REMOVE 1ST INDEX FROM LNKNAM - RPG                      MAN  190
C     3/14/80 - REMOVE BOTH ABOVE CHANGES - S.P.                        MAN  200
C     7/28/81 - PRINT LOCATION OF LOAD - S.P.                           MAN  210
C                                                                       MAN  220
      IMPLICIT REAL*8 ( A-H, O-Z )                                      MAN  230
      COMMON /LNKBLK/ NUMLNK, IUNIQU, LNKADR(6,12)                      MAN  240
      CHARACTER*8 LNKNAM(3,12)
      EQUIVALENCE ( LNKNAM(1,1), LNKADR(1,1) )                          MAN  240
C                                                                       MAN  250
      CHARACTER*8 AKEY                                                  MAN  260
      CHARACTER*8 WORD
      CHARACTER*8 AKEYS(12)                                             MAN  270
      DATA AKEYS/'REALPOTE', 'IMAGPOTE', 'REALSOPO', 'IMAGSOPO', 'COULOMMAN  270
     *BP', 'WAVEFUNC', 'REALTRPO', 'IMAGTRPO', 'REALTLPO', 'IMAGTLPO', 'MAN  270
     *REALTPRP', 'IMAGTPRP'/                                            MAN  270
C                                                                       MAN  300
C     FOR NON-IBM WE NEED A LIST OF SUBROUTINE (=LINKUL) NAMES          MAN  310
C                                                                       MAN  320
      DATA NUMNAM /15/                                                  MAN  330
      CHARACTER*8 NAMES(15)
      DATA NAMES/'BKGPTELP', 'FIXEDWOO', 'GAUSSIAN', 'LAGRANGE', 'LTSTELMAN  340
     *P ', 'OHTA    ', 'PARITWOO', 'RAWITSCH', 'REID    ', 'SHAPE   ',  MAN  340
     * 'SPLINE ','TWOSHAPE','DEFORM','JDEPEN','JDEPE1'/
      EXTERNAL BKGPTE, FIXEDW, GAUSSI, LAGRAN, LTSTEL, OHTA , PARITW, RAMAN  370
     *WITS, REID , SHAPE , SPLINE, twosha,deform,jdepen,jdepe1                               
C                                                                       MAN  400
      CHARACTER*8 INTERN
      DATA INTERN / 'INTERNAL' /                                        MAN  420
C                                                                       MAN  470
C     FIND THE KEY                                                      MAN  480
C                                                                       MAN  490
      DO 19 IKEY = 1, NUMLNK                                            MAN  500
      IF ( AKEY .EQ. AKEYS(IKEY) ) GO TO 50                             MAN  510
 19   CONTINUE                                                          MAN  520
C                                                                       MAN  530
C     GET THE LINKULE NAME                                              MAN  540
C                                                                       MAN  550
 50   CALL NXWORD ( WORD, &900, &900, &900 )                            MAN  560
      LNKNAM(1,IKEY) = WORD                                             MAN  570
      ILOC = 0                                                          MAN  580
      IF ( WORD .EQ. INTERN ) GO TO 200                                 MAN  590
C                                                                       MAN  600
C     LOAD IT                                                           MAN  620
C     IN THE NON-IBM VERSIONS THE LINKULES ARE IN THE OVERLAY           MAN  790
C                                                                       MAN  800
      DO 109 I = 1, NUMNAM                                              MAN  810
      IF ( WORD .EQ. NAMES(I) ) GO TO 140                               MAN  820
 109  CONTINUE                                                          MAN  830
      PRINT 113, WORD                                                   MAN  840
 113  FORMAT ( '0*** ', A8, ' IS NOT IN THIS VERSION OF PTOLEMY.' )     MAN  850
      GO TO 950                                                         MAN  860
C                                                                       MAN  870
 140  GO TO ( 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151, 152MAN  880
	2,153,154,155),I
 141  ILOC = %LOC(BKGPTE)                                               MAN  910
      GO TO 200                                                         MAN  920
 142  ILOC = %LOC(FIXEDW)                                               MAN  930
      GO TO 200                                                         MAN  940
 143  ILOC = %LOC(GAUSSI)                                               MAN  950
      GO TO 200                                                         MAN  960
 144  ILOC = %LOC(LAGRAN)                                               MAN  970
      GO TO 200                                                         MAN  980
 145  ILOC = %LOC(LTSTEL)                                               MAN  990
      GO TO 200                                                         MAN 1000
 146  ILOC = %LOC(OHTA)                                                 MAN 1010
      GO TO 200                                                         MAN 1020
 147  ILOC = %LOC(PARITW)                                               MAN 1030
      GO TO 200                                                         MAN 1040
 148  ILOC = %LOC(RAWITS)                                               MAN 1050
      GO TO 200                                                         MAN 1060
 149  ILOC = %LOC(REID)                                                 MAN 1070
      GO TO 200                                                         MAN 1080
 150  ILOC = %LOC(SHAPE)                                                MAN 1090
      GO TO 200                                                         MAN 1100
 151  ILOC = %LOC(SPLINE)                                               MAN 1110
      GO TO 200                                                         MAN 1120
 152  ILOC = %LOC(TWOSHA)                                               MAN 1130
           GO TO 200
 153      ILOC=%LOC(DEFORM)
	GO TO 200
 154       ILOC=%LOC(JDEPEN)
           GO TO 200
 155       ILOC=%LOC(JDEPE1)
C                                                                       MAN 1160
 200  LNKADR(3,IKEY) = ILOC                                             MAN 1170
      PRINT 203, WORD, ILOC                                             MAN 1180
 203  FORMAT ( ' LINKULE ', A8, ' LOADED AT LOCATION ', Z8 )            MAN 1190
CDC     1  O12 )                                                        MAN 1210
      IRET = 1                                                          MAN 1220
      RETURN                                                            MAN 1230
C                                                                       MAN 1240
 900  PRINT 903, AKEY                                                   MAN 1250
 903  FORMAT ( '0**** A LINKULE NAME MUST FOLLOW THE ', A8, ' KEYWORD.' MAN 1260
     *)                                                                 MAN 1260
 950  IRET = 0                                                          MAN 1280
      RETURN                                                            MAN 1290
      END
      
      SUBROUTINE SAVEHS ( IRET )                                        MAN   20
C                                                                       MAN   50
C     INITIALIZE THE SAVING AND RESTORING OF THE H'S.                   MAN   60
C                                                                       MAN   70
C                                                                       MAN   80
C     THE SAVEHS FILE IS A SEQUENTIAL DATA SET WRITTEN WITHOUT FORMAT   MAN   90
C     CONTROL.  IT CONTAINS THE FOLLOWING LOGICAL RECORDS.              MAN  100
C                                                                       MAN  110
C     1)  SAVEHS HEADER; DATE; REACTION; HEADER                         MAN  120
C     2)  COMMONS FOR FIRST BOUNDSTATE.                                 MAN  130
C     3)  COMMONS FOR SECOND BOUNDSTATE.                                MAN  140
C     4)  COMMONS AT START OF GRID SETUP.                               MAN  150
C       ITEMS 2, 3, AND 4 HAVE THE SAME FORMAT AND ARE PRODUCED         MAN  160
C       BY THE ENTRY 'SAVECM' BELOW.                                    MAN  170
C     5)  GRDSET VARIABLES STARTING WITH  NPSUM, NPDIF, ...             MAN  180
C     6) A)  DIF-RANGE POLYS                                            MAN  190
C        B)  SUM POINTS FOR FINDING H'S                                 MAN  200
C        C)  1/(EXPONENTIAL TAILS) THAT ARE MULTIPLIED INTO             MAN  210
C            THE COMPUTED H'S.                                          MAN  220
C        D)  RI POINTS FOR FINDING H'S                                  MAN  230
C        E)  RO POINTS FOR FINDING H'S                                  MAN  240
C     7)  NUMLIS  -  A SINGLE INTEGER.                                  MAN  250
C     8)  LIS - THE ARRAY OF LI'S ATWHICH STUFF WAS COMPUTED.           MAN  260
C     9)  H-RECORDS.  THERE IS ONE FOR EACH VALUE OF (LI, AND DIF).     MAN  270
C         EACH RECORD CONSISTS OF AN IDENTIFIER,                        MAN  280
C         AND THE HS FOR EACH VALUE OF (SUM, LX, LO-LI).                MAN  290
C             THE H'S HAVE BEEN MULTIPLIED BY THE EXP FACTORS IN 6.C    MAN  300
C         A DUMMY H-RECORD WITH A VERY LARGE IDENTIFIER IS WRITTEN      MAN  310
C         AT THE END OF THE H'S.                                        MAN  320
C                                                                       MAN  330
C           FOR MULTIPASS RUNS, RECORD TYPES 2-9 REPEAT FOR EACH PASS,  MAN  340
C     EXCEPT THAT RECORD 2 OR 3 MAY BE OMITTED IF NO CHANGE.            MAN  350
C     THE SEQUENCE TERMINATES GRACEFULLY AT AN END-OF-FILE.             MAN  360
C                                                                       MAN  370
C                                                                       MAN  380
C     6/10/75 - FIRST VERSION                                           MAN  390
C     7/29/75 - DON'T OVERRIDE THE HEADER                               MAN  400
C     9/17/75 - SAVE/RESTORE R0MASS.                                    MAN  410
C     2/29/76 - ADVANCE TO TYPE 2 - INCOMPATABLE WITH EARLIER PTOLEMY   MAN  420
C      5/21/76 - TYPE 3                                                 MAN  430
C     10/3/76 - CONVERT OLD UNDEF TO NEW UNDEF                          MAN  440
C     4/25/78 - TYPE 4 FOR REVERSAL OF LIN, LOUT - S.P.                 MAN  450
C     5/13/79 - TYPE 5 FOR PARITIES, RATMAS.  RECONSTRUCT TYPE 4 - S.P. MAN  460
C     10/26/79 - STANDARDIZE, TERMINATE GRACEFULLY AT EOF IN MULTIPASS  MAN  470
C        USEHS RUNS - RPG                                               MAN  480
C     2/5/80 - CHAR*8 DATE, THISDT; CVA OPEN SAVEHS FILE;               MAN  490
C        INTGER TO INTGR; CVA COMMON /INTGER/ - RPG                     MAN  500
C                                                                       MAN  510
C     THE  SAVEHS  KEYWORD WAS USED.  CHECK VALIDITY AND INITIALIZE     MAN  520
C                                                                       MAN  530
      IMPLICIT REAL*8 ( A-H, O-Z )                                      MAN  540
      INTEGER PARITS, PARIPT, PARITY                                    MAN  550
      COMMON /INTGER/ L, LMAX, LMIN, LOOKST, LX, MAPSUM, MAPDIF, MAXITR,MAN  550
     * NAITKN, NBACK, NCOSIN, NODES, NPDIF, NPHIAD, NPPHI, NPSUM, IPRINTMAN  550
     *, ISIZE, IZS(5), IZP, IZT, LSTEP, LBACK, MAXLEX, LMAXAD, MAXFUN, IMAN  550
     *REINI, MODEFT, NUMRAN, NVPOLY, NPCOUL, MXCOUL, LMINSB, PARITS(5), MAN  550
     *PARIPT(2), PARITY, IPARM1, IPARM2, IPARM3, IPARM4, IPARM5, NBLKSZ,MAN  550
     * MAPPHI, NFIROF, LEBACK                                           MAN  550
      LOGICAL*1 WASSET                                                  MAN  560
      COMMON /INTRNL/ UNDEF, NOTDEF, ICHANB, ICHANW, ICNTT, EBNDS(2), IDMAN  560
     *ONE, ISTRIP, IHSAVE, NEXTSV, IPOT, IWFN, LIMOST, IEXCIT, R0MASS, WMAN  560
     *ASSET(40), RATMAS, LSPECS(4), NODESP(4), LSPCPT(2), NODEPT(2),ICD3MAN  560
     *I                                                                 MAN  560
C JRB 5/92 add float common, since amt used here but not defined ???
      COMMON /FLOAT/ A, ACCURA, AI, ANGSTP, ANGMIN, ANGMAX, ASO, ASOI, AMAN  560
     *SYMPT, DELTVK, DWCUT, E, ECM, ELAB, EXS(5), GAMDIF, GAMSUM, TAU, TMAN  560
     *AUI, AM, AMA, AMB, AMBIGA, AMBIGB, AMX, AMXCS(5), AMXCGS(5), AMP, MAN  560
     *AMT, Q, R, R0, RC, RC0, RI, RI0, RSO, RSO0, RSOI, RSOI0, SPAM, SPAMAN  560
     *MP, SPAMT, STEPSZ, STEP1R, STEP1I, SUMMAX, SUMMID, SUMMIN, V, VI, MAN  560
     *VSO, VSOI, FITMUL, WRITES, ASI, RSI, RSI0, VSI, AMDMLT, STPSPR, R0MAN  560
     *E, RI0E, AE, AIE, VE, VIE, FITACC, ALMNMT, SPFACP, SPFACT, R0ESQ, MAN  560
     *RI0ESQ, AESQ, AIESQ, VESQ, VIESQ, DERIVS, FITRAT, RCP, RCT, RC0P, MAN  560
     *RC0T, SUMPTS, ACCINE, COULML, ALMXMT, EXSPT(2), POWRL, POWIM, BNDAMAN  560
     *SY, SCTASY, VTR,VTRI,VTL,VTLI,VTP,VTPI, PARAM1, PARAM2, PARAM3, PAMAN  560
     *RAM4, PARAM5, PAR620(15), RTR, RTRI, RTL, RTLI, RTP, RTPI, RTR0, RMAN  560
     *TRI0, RTL0, RTLI0, RTP0, RTPI0, ATR, ATRI, ATL, ATLI, ATP, ATPI, AMAN  560
     *MXGPT(2), PHIMID, GAMPHI                                          MAN  560
C JRB 5/92 add float common, since amt used here but not defined ???
      CHARACTER*1 REACT, HEADER                                         MAN  570
      COMMON /HEDCOM/ REACT(45), HEADER(65)                             MAN  570
C                                                                       MAN  580
      DIMENSION FLOATK(NUMFLT)                                          MAN  590
      INTEGER INTGR(NUMINT), JBLOCK(NUMJ), SWITCH(NUMSW)                MAN  600
C                                                                       MAN  610
      CHARACTER*1 THEDAT(18), HEADR2(65), BLNK1                         MAN  630
      DATA BLNK1/' '/                                                   MAN  630
C                                                                       MAN  640
      CHARACTER*8 HED(4), HED2(4)                                       MAN  650
CDC      INTEGER HED(2), HED2(2)                                        MAN  660
      DATA HED / 'PTOLEMY ', 'SAVEHS F', 'ILE     ', '        ' /       MAN  670
CDC      DATA HED / 'PTOLEMY SAVEHS FILE' /                             MAN  680
      CHARACTER*8 DATE, THISDT                                          MAN  690
      INTEGER TYPE,TYPE2                                                MAN  700
      DATA TYPE / 5 /                                                   MAN  700
C                                                                       MAN  710
      IRET = 0                                                          MAN  800
C                                                                       MAN  810
C     CAN ONLY HAVE SAVEHS OR USEHS; NOT BOTH                           MAN  820
C                                                                       MAN  830
      IF ( IHSAVE .EQ. 0 ) GO TO 40                                     MAN  840
 32   PRINT 33                                                          MAN  850
 33   FORMAT ( '0**** SAVEHS AND USEHS ARE EXCLUSIVE; OR ',  ' SAVEHS ORMAN  860
     * USEHS HAS ALREADY BEEN ENTERED.' )                               MAN  860
      RETURN                                                            MAN  880
C                                                                       MAN  890
 40   IF ( IDONE .EQ. 0 ) GO TO 50                                      MAN  900
 42   PRINT 43                                                          MAN  910
 43   FORMAT ( '0**** IT IS TOO LATE TO INITIALIZE FOR SAVEHS',  ' OR USMAN  920
     *EHS.' )                                                           MAN  920
      RETURN                                                            MAN  940
C                                                                       MAN  950
 50   CONTINUE                                                          MAN 1070
C                                                                       MAN 1080
C     OPEN THE OUTPUT FILE                                              MAN 1090
C                                                                       MAN 1100
      NBLKSZ = MAX0( (NBLKSZ+511)/512, 1 )*512                          MAN 1110
      NBLKS = LENHF( IDUM )/NBLKSZ + 1                                  MAN 1120
      PRINT 53, NBLKSZ, NBLKS                                           MAN 1130
 53   FORMAT ( '0BLOCK SIZE OF H"S FILE =', I6,  ' BYTES, INITIAL SIZE =MAN 1140
     *', I6, ' BLOCKS.' )                                               MAN 1140
      OPEN ( UNIT=1, TYPE='NEW', DISP='SAVE', BLOCKSIZE=NBLKSZ,  FORM='UMAN 1160
     *NFORMATTED', INITIALSIZE=NBLKS, ERR=90 )                          MAN 1160
CNV      REWIND 1                                                       MAN 1180
      THISDT = DATE(THISDT)                                             MAN 1190
      CALL EDTDAT ( THEDAT, N, THISDT )                                 MAN 1200
      WRITE ( 1, ERR=90 ) HED, TYPE, THEDAT, REACT, HEADER              MAN 1210
C                                                                       MAN 1220
      IHSAVE = 1                                                        MAN 1230
      IRET = 1                                                          MAN 1240
      RETURN                                                            MAN 1250
C                                                                       MAN 1260
 90   PRINT 93                                                          MAN 1270
 93   FORMAT ( '0**** ERROR IN INITIALIZING H  S FILE.' )               MAN 1280
      RETURN                                                            MAN 1290
C                                                                       MAN 1310
C     WRITE THE COMMON BLOCKS AFTER EACH BOUND STATE AND BEFORE         MAN 1320
C     GRDSET.                                                           MAN 1330
C                                                                       MAN 1340
      ENTRY SAVECM ( NUMFLT, FLOATK, NUMINT, INTGR, NUMJ, JBLOCK, NUMSW,MAN 1350
     * SWITCH, IRET )                                                   MAN 1350
C                                                                       MAN 1370
      TEMP = 0                                                          MAN 1380
      WRITE ( 1, ERR=190 ) ICHANB, ISTRIP, NUMFLT, NUMINT,  NUMJ, NUMSW,MAN 1390
     * FLOATK, INTGR, JBLOCK, SWITCH, R0MASS,  RATMAS, TEMP, TEMP, TEMP,MAN 1390
     * TEMP, TEMP                                                       MAN 1390
      IRET = 1                                                          MAN 1430
      RETURN                                                            MAN 1440
C                                                                       MAN 1450
 190  PRINT 193                                                         MAN 1460
 193  FORMAT ( '0**** ERROR IN WRITING ON H  S FILE.' )                 MAN 1470
      IRET = 0                                                          MAN 1480
      RETURN                                                            MAN 1490
C                                                                       MAN 1510
C     USEHS KEYWORD READ - INITIALIZE H'S INPUT                         MAN 1520
C                                                                       MAN 1530
      ENTRY USEHS ( NUMFLT, FLOATK, NUMINT, INTGR, NUMJ, JBLOCK, NUMSW, MAN 1540
     *SWITCH, IRET )                                                    MAN 1540
C                                                                       MAN 1560
      GO TO ( 200, 300, 300 ), IRET                                     MAN 1570
C                                                                       MAN 1580
 200  IRET = 0                                                          MAN 1590
      IF ( IHSAVE .NE. 0 ) GO TO 32                                     MAN 1600
      IF ( IDONE .NE. 0 ) GO TO 42                                      MAN 1610
C                                                                       MAN 1670
C     OPEN THE INPUT FILE                                               MAN 1680
C                                                                       MAN 1690
      REWIND 1                                                          MAN 1700
      READ ( 1, ERR=90, END=90 ) HED2, TYPE2, THEDAT, REACT, HEADR2     MAN 1710
      DO 239 I = 1, 2                                                   MAN 1720
      IF ( HED2(I) .EQ. HED(I) ) GO TO 239                              MAN 1730
      PRINT 233                                                         MAN 1740
CIB 233     FORMAT ('0**** FT01F001 DOES NOT POINT TO A SAVEHS FILE.')  MAN 1750
 233  FORMAT ('0**** TAPE1 DOES NOT POINT TO A SAVEHS FILE.')           MAN 1760
      RETURN                                                            MAN 1770
 239  CONTINUE                                                          MAN 1780
C                                                                       MAN 1790
      PRINT 253, THEDAT, REACT, HEADR2                                  MAN 1800
 253  FORMAT ( '  ON ', 18A1, ' ARE BEING REUSED.' /  '0 ', 45A1, 5X, 65MAN 1810
     *A1 / )                                                            MAN 1810
      DO 265 I = 1, 65                                                  MAN 1830
      IF ( HEADER(I) .NE. BLNK1 ) GO TO 280                             MAN 1840
 265  CONTINUE                                                          MAN 1850
      DO 269 I = 1, 65                                                  MAN 1860
      HEADER(I) = HEADR2(I)                                             MAN 1870
 269  CONTINUE                                                          MAN 1880
C                                                                       MAN 1890
 280  IF ( TYPE .EQ. TYPE2 ) GO TO 300                                  MAN 1900
      IF ( TYPE2 .EQ. 4 ) GO TO 300                                     MAN 1910
      PRINT 283, TYPE, TYPE2                                            MAN 1920
 283  FORMAT ( '0THE H  S FILE IS INCOMPATABLE WITH THE PRESENT',  ' VERMAN 1930
     *SION OF PTOLEMY:', 2I10 )                                         MAN 1930
      RETURN                                                            MAN 1950
C                                                                       MAN 1960
C     READ BOUNDSTATE AND GRDSET COMMONS                                MAN 1970
C                                                                       MAN 1980
 300  READ ( 1, ERR=390, END=380 ) ICHANB, ISTRIP,  NF, NI, NJ, NS,     MAN 1990
     * (FLOATK(I), I=1,NF), (INTGR(I), I = 1,NI), (JBLOCK(I), I = 1,    MAN 1990
     * NJ ), ( SWITCH(I), I = 1, NS ), R0MASS,  RATMAS                  MAN 1990
      IHSAVE = 2                                                        MAN 2040
      IRET = 1                                                          MAN 2050
C                                                                       MAN 2120
C     TYPE 4 SAVEHS HAVE RATMAS = 0.  WE SET RATMAS = AMP/AMT AND       MAN 2130
C     INDICATE ALL PARITES ARE UNKNOWN.                                 MAN 2140
C                                                                       MAN 2150
      IF ( RATMAS .NE. 0 ) RETURN                                       MAN 2160
      RATMAS = AMP/AMT                                                  MAN 2170
      DO 339 I = 33, 40                                                 MAN 2180
      INTGR(I) = 0                                                      MAN 2190
 339  CONTINUE                                                          MAN 2200
      RETURN                                                            MAN 2210
C                                                                       MAN 2220
C                                                                       MAN 2230
C     IN A MULTIPASS RUN, AN END OF FILE MAY BE OK.                     MAN 2240
C                                                                       MAN 2250
 380  IF ( IRET .NE. 3 ) GO TO 390                                      MAN 2260
      PRINT 383                                                         MAN 2270
 383  FORMAT ( '0', 10X, '**** END OF H  S FILE ****' )                 MAN 2280
      IRET = -1                                                         MAN 2290
      IHSAVE = 0                                                        MAN 2300
      RETURN                                                            MAN 2310
 390  PRINT 393                                                         MAN 2320
 393  FORMAT ( '0**** ERROR OR UNEXPECTED END-OF-FILE WHEN',  ' READING MAN 2330
     *H  S FILE' )                                                      MAN 2330
      IRET = 0                                                          MAN 2350
      RETURN                                                            MAN 2360
      END
      
      SUBROUTINE LINKUL ( LOC,ALIAS,MYINTS,IPOTYP,IREQUE,IRETUR,L,      MAN   20
     * J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, ID )                  MAN   20
C                                                                       MAN   40
C     LINKULE CALLER FOR PTOLEMY                                        MAN   50
C                                                                       MAN   60
C     THIS ROUTINE ADDS THE FIXED PART OF A LINKULE ARGUMENT LIST       MAN   70
C     TO THE ABOVE ARGUMENTS AND THEN CALLS THE LINKULE.                MAN   80
C     THE LINKULE MUST ALREADY BE LOADED IN CORE AND LOC MUST BE ITS    MAN   90
C     ENTRY POINT ADDRESS.                                              MAN  100
C     UPON RETURN, THE STUFF WRITTEN IN IUNIT WILL BE COPIED TO THE     MAN  110
C     PRINTER.                                                          MAN  120
C                                                                       MAN  130
C     11/25/77 - FIRST VERSION - S.P.                                   MAN  140
C     7/6/78 - CDC VERSION                                              MAN  150
C     5/6/79 - PASS IPARAM ARRAY SEPARATELY - S.P.                      MAN  160
C     12/28/79 - STANDARD MORTRAN - RPG                                 MAN  170
C     7/30/80 - IUNIT IS 6 FOR CDC - S.P.                               MAN  180
C                                                                       MAN  190
      IMPLICIT REAL*8 ( A-H, O-Z )                                      MAN  200
C                                                                       MAN  210
      DIMENSION MYINTS(2), ARRAY1(1), ARRAY2(1)                         MAN  220
      INTEGER*4 Z                                                       MAN  240
      COMMON /LOCKT/ Z(100)                                             MAN  240
      INTEGER FACFR4, FACFR2, FACFR1                                    MAN  240
      COMMON /ALLOCS/ FACFR4, FACFR2, FACFR1                            MAN  240
      DIMENSION ALLOC(1)                                                MAN  240
      LOGICAL*1 MLLOC(1)                                                MAN  240
      REAL*4 ALLOC4(1)                                                  MAN  240
      INTEGER ILLOC(1)                                                  MAN  240
      INTEGER*2 ILLOC2(1)                                               MAN  240
      EQUIVALENCE ( FACFR4, ALLOC(1), ILLOC(1), ILLOC2(1), ALLOC4(1), MLMAN  240
     *LOC(1) )                                                          MAN  240
      COMMON / LENGTH / LENG(1)                                         MAN  250
      COMMON / FLOAT / F(153)                                           MAN  270
      COMMON / INTGER/ I(46)                                            MAN  280
      COMMON / JBLOCK / JB(1)                                           MAN  290
      COMMON / SWITCH / IS(1)                                           MAN  300
      COMMON / CNSTNT / C(1)                                            MAN  310
      COMMON / TEMPVS / T(1)                                            MAN  320
      COMMON / WAVCOM / WAV(1)                                          MAN  330
      COMMON / KANDM / KM(1)                                            MAN  340
      COMMON / INTRNL / IN(1)                                           MAN  350
C                                                                       MAN  360
      EXTERNAL NALLOC, NAMLOC                                           MAN  370
      DATA IUNIT /10/                                                   MAN  390
CDC      DATA IUNIT /6/                                                 MAN  400
C                                                                       MAN  410
      CHARACTER*1 LINE(133)                                             MAN  420
C     NOTE:                                                             MAN  470
C     F(112) IS BEGINING OF PARAM'S                                     MAN  490
C     I(46) IS BEGINNING OF IPARAM'S                                    MAN  500
C      write(6,1996) alias
C1996  format(/,' I am now in LINKUL: ',A8/) 
      IF(ALIAS.EQ.'SHAPE') THEN
      CALL SHAPE(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'SPLINE') THEN
      CALL SPLINE(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'BKGPTELP') THEN
      CALL BKGPTE(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC, I(46))
      ELSE IF(ALIAS.EQ.'DEFORM') THEN
      CALL DEFORM(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC, I(46) )
      ELSE IF(ALIAS.EQ.'OHTA') THEN
      CALL OHTA(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'PARITWOO') THEN
      CALL PARITW(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'FIXEDWOO') THEN
      CALL FIXEDW(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'GAUSSIAN') THEN
      CALL GAUSSI(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'JDEPE1') THEN
      CALL JDEPE1(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'JDEPEN') THEN
      CALL JDEPEN(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'LAGRANGE') THEN
      CALL LAGRAN(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'LTSTELP') THEN
      CALL LTSTEL(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC, I(46))
      ELSE IF(ALIAS.EQ.'RAWITSCH') THEN
      CALL RAWITS(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      ELSE IF(ALIAS.EQ.'REID') THEN
      CALL REID(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC, I(46))
      ELSE IF(ALIAS.EQ.'TWOSHAPE') THEN
      CALL TWOSHA(ALIAS, MYINTS, IPOTYP, IREQUE, IRETUR, IUNIT, NUMOUT,                                                  MAN  530
     &  L, J, RSTART, STEPSZ, NUMPTS, ARRAY1, ARRAY2, F, T, F(112), I, 
     & JB, IS, IN, IN, C, WAV, KM, ID, ALLOC, ILLOC, FACFR4, Z, LENG, 
     & NALLOC, NAMLOC )
      END IF
C      write(6,1996) alias 
C                                                                       MAN  580
      IF ( NUMOUT .EQ. 0 )  RETURN                                      MAN  590
C                                                                       MAN  600
 150  READ ( IUNIT, 153, END=200 )  LINE                                MAN  610
 153  FORMAT ( 133A1 )                                                  MAN  620
      PRINT 153, LINE                                                   MAN  630
      GO TO 150                                                         MAN  640
 200  REWIND IUNIT                                                      MAN  650
      RETURN                                                            MAN  660
      END
C            
      SUBROUTINE KEEPIT                                                 MAN   20
C                                                                       MAN   30
C     PERFORMS SPEAKEASY KEEP OPERATION FOR PTOLEMY                     MAN   40
C                                                                       MAN   50
C     PTOLEMY INPUT IS                                                  MAN   60
C                                                                       MAN   70
C     KEEP  OBJECTNAME  MEMBERNAME                                      MAN   80
C                                                                       MAN   90
C     OBJECTNAME MAY BE EITHER THE NAME OF AN OBJECT IN THE ALLOCATOR   MAN  100
C     OR ONE OF THE FOLLOWING SPECIAL NAMES                             MAN  110
C       ANGLEGRID - KEEPS ANGLESTEP, ANGLEMIN, ANGLEMAX                 MAN  120
C       HEADER - KEEPS THE HEADER WITHOUT LEADING BLANKS                MAN  130
C       REACTION - KEEPS THE REACTION WITHOUT TRAILING BLANKS           MAN  140
C       ELAB                                                            MAN  150
C                                                                       MAN  160
C     THE PDS IS REFERED TO BY THE DDNAME MYKEEP.                       MAN  170
C                                                                       MAN  180
C     11/7/76 - FIRST VERSION                                           MAN  190
C     4/9/78 - CHIGNVEC ADDED TO LIST - S.P.                            MAN  200
C     4/25/78 - LI AND LO INTERCHANGED - S.P.                           MAN  210
C     4/27/78 - I AND ISUM ADDED TO SPECIAL NAMES - S.P.                MAN  220
C     3/6/79 - S MATRICES - S.P.                                        MAN  230
C     12/28/79 - STANDARD MORTRAN - RPG                                 MAN  240
C     1/16/80 - CHARACTER*8 OBNAME, MOVE CIB%F DOWN - RPG               MAN  250
C     12/14/18 - CROSSSECTIONS, F, ETC BY ANGLE GRID - S.P.             MAN  260
C                                                                       MAN  270
      IMPLICIT REAL*8 ( A-H, O-Z )                                      MAN  280
C                                                                       MAN  290
      INTEGER*4 Z                                                       MAN  300
      COMMON /LOCKT/ Z(100)                                             MAN  300
      INTEGER FACFR4, FACFR2, FACFR1                                    MAN  300
      COMMON /ALLOCS/ FACFR4, FACFR2, FACFR1                            MAN  300
      DIMENSION ALLOC(1)                                                MAN  300
      LOGICAL*1 MLLOC(1)                                                MAN  300
      REAL*4 ALLOC4(1)                                                  MAN  300
      INTEGER ILLOC(1)                                                  MAN  300
      INTEGER*2 ILLOC2(1)                                               MAN  300
      EQUIVALENCE ( FACFR4, ALLOC(1), ILLOC(1), ILLOC2(1), ALLOC4(1), MLMAN  300
     *LOC(1) )                                                          MAN  300
      COMMON /LENGTH/ LENG(1)                                           MAN  310
C                                                                       MAN  320
      COMMON /FLOAT/ A, ACCURA, AI, ANGSTP, ANGMIN, ANGMAX, ASO, ASOI, AMAN  330
     *SYMPT, DELTVK, DWCUT, E, ECM, ELAB, EXS(5), GAMDIF, GAMSUM, TAU, TMAN  330
     *AUI, AM, AMA, AMB, AMBIGA, AMBIGB, AMX, AMXCS(5), AMXCGS(5), AMP, MAN  330
     *AMT, Q, R, R0, RC, RC0, RI, RI0, RSO, RSO0, RSOI, RSOI0, SPAM, SPAMAN  330
     *MP, SPAMT, STEPSZ, STEP1R, STEP1I, SUMMAX, SUMMID, SUMMIN, V, VI, MAN  330
     *VSO, VSOI, FITMUL, WRITES, ASI, RSI, RSI0, VSI, AMDMLT, STPSPR, R0MAN  330
     *E, RI0E, AE, AIE, VE, VIE, FITACC, ALMNMT, SPFACP, SPFACT, R0ESQ, MAN  330
     *RI0ESQ, AESQ, AIESQ, VESQ, VIESQ, DERIVS, FITRAT, RCP, RCT, RC0P, MAN  330
     *RC0T, SUMPTS, ACCINE, COULML, ALMXMT, EXSPT(2), POWRL, POWIM, BNDAMAN  330
     *SY, SCTASY, VTR,VTRI,VTL,VTLI,VTP,VTPI, PARAM1, PARAM2, PARAM3, PAMAN  330
     *RAM4, PARAM5, PAR620(15), RTR, RTRI, RTL, RTLI, RTP, RTPI, RTR0, RMAN  330
     *TRI0, RTL0, RTLI0, RTP0, RTPI0, ATR, ATRI, ATL, ATLI, ATP, ATPI, AMAN  330
     *MXGPT(2), PHIMID, GAMPHI                                          MAN  330
      DIMENSION PARAMS(20)                                              MAN  330
      EQUIVALENCE ( PARAMS(1), PARAM1 )                                 MAN  330
      DIMENSION AMS(5)                                                  MAN  330
      EQUIVALENCE ( AMS(1), AMA )                                       MAN  330
      DIMENSION VTEN(6), RTEN(6), RTEN0(6), ATEN(6)                     MAN  330
      EQUIVALENCE ( VTEN(1), VTR ), (RTEN(1), RTR ), (RTEN0(1), RTR0 ), MAN  330
     *(ATEN(1), ATR )                                                   MAN  330
      CHARACTER*1 REACT, HEADER                                         MAN  340
      COMMON /HEDCOM/ REACT(45), HEADER(65)                             MAN  340
      LOGICAL ONELSW, IDENSW                                            MAN  350
      COMMON /INELCM/ JBPF, JBTF, LXMIN, LXMAX, ILILOR, ILILOI, MSTOP, IMAN  350
     *A12M, NMLOLX, ONELSW, NUMLX, IRDINT, IELCUP, LILOSZ, NUMLIS, ILIS,MAN  350
     * IBETAS(3), ICL2FF, LXSTEP, IDENSW, LSKIP, JPMIN, JPMAX, JPBASE, NMAN  350
     *JP, JTMIN, JTMAX, JTBASE, NJT, IINDXS, ISMATR, ISMATI, NSMAT, NLX,MAN  350
     * NSPLI, ITOCS, NASPLI, IUNITR, LIFIT, ILIFIT, NOLFIT, IDELSR, IDELMAN  350
     *SI                                                                MAN  350
      INTEGER INDXJS(4,2)                                               MAN  350
      EQUIVALENCE ( INDXJS(1,1), JPMIN )                                MAN  350
C                                                                       MAN  360
C                                                                       MAN  370
      CHARACTER*1 BLANK                                                 MAN  380
      DATA BLANK / ' ' /                                                MAN  380
      CHARACTER*8 OBNAME, MEMBER, MYKEEP, AS                            MAN  390
      DATA AS/'AS'/                                                     MAN  390
      DATA MYKEEP/'MYKEEP'/                                             MAN  390
C                                                                       MAN  400
      DATA NSPECL / 16 /                                                MAN  410
      CHARACTER*8 SPECIL(16)                                            MAN  420
      DATA SPECIL/'SMAG', 'SPHASE', 'LXCROSSS', 'MXCROSSS', 'SIN', 'SOUTMAN  420
     *', 'F', 'HEADER', 'REACTION', 'ELAB', 'ANGLEGRI', 'CHIGNVEC', 'S',MAN  420
     * 'ISUM', 'SEL', 'CROSSSEC'/                                       MAN  420
      INTEGER KINDS(16)                                                 MAN  450
      DATA KINDS/2, 2, 2, 2, 4, 4, 4, 9, 9, 2, 2, 2, 4, 4, 4, 2/        MAN  450
      INTEGER KLASSS(16)                                                MAN  470
      DATA KLASSS/6, 6, 6, 6, 5, 5, 6, 5, 5, 0, 5, 2, 6, 6, 5, 6/       MAN  470
      INTEGER ISIZES(16)                                                MAN  490
      DATA ISIZES/8, 8, 8, 8,16,16,16, 1, 1, 8, 8, 8,16,16, 16, 8/      MAN  490
      INTEGER IGOTOS(16)                                                MAN  510
      DATA IGOTOS/2, 2, 3, 3, 1, 1, 3, 4, 5, 6, 7, 8, 2, 2, 1, 3/       MAN  510
C                                                                       MAN  540
      CALL NXWORD ( OBNAME, &900, &900, &900 )                          MAN  550
 50   CALL NXWORD ( MEMBER, &900, &900, &900 )                          MAN  560
      IF ( MEMBER .EQ. AS ) GO TO 50                                    MAN  570
C                                                                       MAN  580
C     IS IT IN THE ALLOCATOR                                            MAN  590
C                                                                       MAN  600
      IOB = NAMLOC(OBNAME)                                              MAN  610
      LOCOB = Z(IOB)                                                    MAN  620
      LENOB = LENG(IOB)                                                 MAN  630
C                                                                       MAN  640
C     SET UP KIND, ETC                                                  MAN  650
C                                                                       MAN  660
      KIND = 2                                                          MAN  670
      KLASS = 5                                                         MAN  680
      ISIZE = 8                                                         MAN  690
      NCOLS = 1                                                         MAN  700
      NROWS = 0                                                         MAN  710
C                                                                       MAN  720
C     SEE IF WE KNOW SOMETHING SPECIAL ABOUT IT                         MAN  730
C                                                                       MAN  740
      DO 189 I = 1, NSPECL                                              MAN  750
      IF ( SPECIL(I) .EQ. OBNAME ) GO TO 200                            MAN  760
 189  CONTINUE                                                          MAN  770
      GO TO 500                                                         MAN  780
C                                                                       MAN  790
C     PROCESS SPECIAL STUFF                                             MAN  800
C                                                                       MAN  810
 200  KIND = KINDS(I)                                                   MAN  820
      KLASS = KLASSS(I)                                                 MAN  830
      ISIZE = ISIZES(I)                                                 MAN  840
      IGOTO = IGOTOS(I)                                                 MAN  850
      GO TO ( 500, 220, 230, 240, 250, 260, 270, 280 ), IGOTO           MAN  860
C                                                                       MAN  870
C                                                                       MAN  880
 220  NCOLS = NMLOLX                                                    MAN  890
      GO TO 500                                                         MAN  900
C                                                                       MAN  910
C     SOMETHING ON THE ANGLE GRID                                       MAN  920
C                                                                       MAN  930
 230  NCOLS = (ANGMAX-ANGMIN)/ANGSTP + 1.5                              MAN  940
      IF ( 8*LENOB/ISIZE .EQ. NROWS ) KLASS = 5                         MAN  950
      GO TO 500                                                         MAN  960
C                                                                       MAN  970
C     HEADER                                                            MAN  980
C                                                                       MAN  990
 240  DO 244 I = 1, 65                                                  MAN 1000
      IF ( HEADER(I) .NE. BLANK ) GO TO 245                             MAN 1010
 244  CONTINUE                                                          MAN 1020
      I = 65                                                            MAN 1030
 245  CALL KEEP ( HEADER(I), 9, 5, 66-I, 1, MEMBER, MYKEEP, IER )       MAN 1040
      NROWS = 66-I                                                      MAN 1050
      GO TO 265                                                         MAN 1060
C                                                                       MAN 1070
C     REACTION                                                          MAN 1080
C                                                                       MAN 1090
 250  DO 254 I = 1, 45                                                  MAN 1100
      IF ( REACT(46-I) .NE. BLANK ) GO TO 255                           MAN 1110
 254  CONTINUE                                                          MAN 1120
      I = 45                                                            MAN 1130
 255  CALL KEEP ( REACT, 9, 5, 46-I, 1, MEMBER, MYKEEP, IER )           MAN 1140
      NROWS = 46-I                                                      MAN 1150
      GO TO 265                                                         MAN 1160
C                                                                       MAN 1170
C     ELAB                                                              MAN 1180
C                                                                       MAN 1190
 260  CALL KEEP ( ELAB, 2, 0, 1, 1, MEMBER, MYKEEP, IER )               MAN 1200
      NROWS = 1                                                         MAN 1210
 265  NCOLS = 1                                                         MAN 1220
      GO TO 800                                                         MAN 1230
C                                                                       MAN 1240
C     ANGLEGRID                                                         MAN 1250
C                                                                       MAN 1260
 270  CALL KEEP ( ANGSTP, 2, 5, 3, 1, MEMBER, MYKEEP, IER )             MAN 1270
      NROWS = 3                                                         MAN 1280
      GO TO 265                                                         MAN 1290
C                                                                       MAN 1300
C     OBJECT IS A SQUARE MATRIX OR ARRAY                                MAN 1310
C                                                                       MAN 1320
 280  NCOLS = DSQRT( (8.*LENOB)/ISIZE + .010D0 )                        MAN 1330
      GO TO 500                                                         MAN 1340
C                                                                       MAN 1350
C     OUTPUT AN OBJECT IN THE ALLOCATOR                                 MAN 1360
C                                                                       MAN 1370
 500  IF ( IOB .EQ. 0 ) GO TO 910                                       MAN 1380
      LENOB = (8*LENOB)/ISIZE                                           MAN 1390
      IF ( NROWS .NE. 0 ) NCOLS = LENOB/NROWS                           MAN 1400
      IF ( NCOLS .NE. 0 ) NROWS = LENOB/NCOLS                           MAN 1410
      LENOB2 = NROWS*NCOLS                                              MAN 1420
      IF ( LENOB .EQ. LENOB2 ) GO TO 600                                MAN 1430
      PRINT 513, OBNAME, LENOB, NROWS,  NCOLS, LENOB2, KIND, KLASS      MAN 1440
 513  FORMAT ( '0**** WARNING: ', A8, ' HAS', I6,  ' ELEMENTS BUT NROWS,MAN 1460
     * NCOLS & OUTPUT LENGHT =', 3I6,  ' KIND, CLASS =', 2I3 )          MAN 1460
      NROWS = LENOB                                                     MAN 1490
      NCOLS = 1                                                         MAN 1500
      KLASS = 5                                                         MAN 1510
C                                                                       MAN 1520
 600  CALL KEEP ( ALLOC(LOCOB), KIND, KLASS, NROWS, NCOLS, MEMBER,  MYKEMAN 1530
     *EP, IER )                                                         MAN 1530
C                                                                       MAN 1550
 800  IF ( IER .NE. 0 ) GO TO 920                                       MAN 1560
      PRINT 803, OBNAME, MEMBER, KIND, KLASS, NROWS, NCOLS              MAN 1570
 803  FORMAT ( 1X, A8, ' HAS BEEN KEPT AS MEMBER ', A8,  5X, 'KIND =', IMAN 1580
     *2, 3X, 'KLASS =', I2,  3X, 'NROWS =', I6, 3X, 'NCOLS =', I6 )     MAN 1580
      RETURN                                                            MAN 1610
C                                                                       MAN 1620
C     ERROR MESSAGES                                                    MAN 1630
C                                                                       MAN 1640
 900  PRINT 903                                                         MAN 1650
 903  FORMAT ( '0**** KEEP MUST BE FOLLOWED BY TWO NAMES.' )            MAN 1660
      GO TO 980                                                         MAN 1670
C                                                                       MAN 1680
 910  PRINT 913, OBNAME                                                 MAN 1690
 913  FORMAT ( '0**** ', A8, ' IS NOT A DEFINED OBJECT.' )              MAN 1700
      RETURN                                                            MAN 1710
 920  PRINT 923, IER, OBNAME, MEMBER                                    MAN 1720
 923  FORMAT ( '0**** ERROR NUMBER ', Z8,  ' ENCOUNTERED WHILE KEEPING 'MAN 1730
     *, A8, ' AS ', A8 )                                                MAN 1730
      RETURN                                                            MAN 1750
C                                                                       MAN 1760
 980  PRINT 983                                                         MAN 1770
 983  FORMAT ( ' **** CONTINUING WITH NEXT INPUT CARD.' )               MAN 1780
      CALL NEWCD                                                        MAN 1790
      RETURN                                                            MAN 1800
C                                                                       MAN 1810
      END  
      
      SUBROUTINE IXSORT(IX,X,N)
	IMPLICIT REAL*8 (A-H,O-Z)
	INTEGER*4 LV(16),UV(16),N,P,LP,UP,IY
	DIMENSION X(1),IX(1)
	DO 5 I=1,N
	IX(I)=I
 5      CONTINUE
	LV(1)=1
	UV(1)=N
	P=1
10      IF(P.LT.1)RETURN
20      IF((UV(P)-LV(P)).GE.1)GO TO 30
	P=P-1
	GO TO 10
30      LP=LV(P)-1
	UP=UV(P)
	Y=X(UP)
	IY=IX(UP)
40      IF((UP-LP).LT.2)GO TO 70
	LP=LP+1
	IF(X(LP).LE.Y)GO TO 40
	X(UP)=X(LP)
	IX(UP)=IX(LP)
50       IF((UP-LP).LT.2)GO TO 60
	UP=UP-1
	IF(X(UP).GE.Y)GO TO 50
	X(LP)=X(UP)
	IX(LP)=IX(UP)
	GO TO 40
60      UP=UP-1
70      X(UP)=Y
	IX(UP)=IY
	IF((UP-LV(P)).GE.(UV(P)-UP))GO TO 80
	LV(P+1)=LV(P)
	UV(P+1)=UP-1
	LV(P)=UP+1
	GO TO 90
80      LV(P+1)=UP+1
	UV(P+1)=UV(P)
	UV(P)=UP-1
90      P=P+1
	GO TO 20
	END
  	
      SUBROUTINE AITKEN(NDEGRE,DELTA,EPSLON,NIN,XIN,FIN,NOUT,
     1 XOUT,FOUT,NFAIL,WORST,WORK)
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION XIN(NIN),FIN(NIN),XOUT(NOUT),FOUT(NOUT),WORK(2,1)
	LOGICAL DELTSW,UPSW
	DELTSW=DELTA.GT.0
	NI=1
	NFAIL=0
	WORST=0
	XMID=XIN((NIN+1)/2)
	NDEGR=MIN0(NDEGRE,NIN-1)
	DO 799 NO=1,NOUT
	X=XOUT(NO)
	UPSW=.FALSE.
	D=DABS(X-XIN(NI))
120     IF(NI.EQ.NIN)GO TO 150
	D2=DABS(X-XIN(NI+1))
	IF(D2.GE.D)GO TO 150
	UPSW=.TRUE.
	NI=NI+1
	D=D2
	GO TO 120
150     IF(UPSW)GO TO 200
160     IF(NI.EQ.1)GO TO 200
	D2=DABS(X-XIN(NI-1))
	IF(D2.GE.D)GO TO 200
	NI=NI-1
	D=D2
	GO TO 160
200     NL=NI-1
	NU=NI+1
	F=FIN(NI)
	WORK(1,1)=X-XIN(NI)
	UPSW=WORK(1,1).LT.0
	WORK(2,1)=F
	ERROR=0
	IF(NDEGR.LE.0)GO TO 700
	DO 599 ND=1,NDEGR
	FLAST=F
	IF(ND.EQ.2)UPSW=X.LT.XMID
	IF(UPSW)GO TO 350
320      I=NU
	NU=NU+1
	UPSW=.TRUE.
	IF(I.LE.NIN)GO TO 400
350     I=NL
	NL=NL-1
	UPSW=.FALSE.
	IF(I.LT.1)GO TO 320
400     DEL=X-XIN(I)
	F=FIN(I)
	DO 489 J=1,ND
	 F=(WORK(1,J)*F-DEL*WORK(2,J))/(WORK(1,J)-DEL)
489     CONTINUE
	IF(.NOT.DELTSW)GO TO 550
	ERROR=DABS(F)
	IF(ERROR.LE.EPSLON)GO TO 700
	ERROR=DABS((F-FLAST)/F)
	IF(ERROR.LE.DELTA)GO TO 700
550     WORK(1,ND+1)=DEL
	WORK(2,ND+1)=F
599     CONTINUE
	IF(DELTSW)NFAIL=NFAIL+1
700     FOUT(NO)=F
	WORST=DMAX1(WORST,ERROR)
799     CONTINUE
	RETURN
	END

C--------------------------------------------------------------------------
	      FUNCTION NALLOC( IWRDS,NAME)
C--------------------------------------------------------------------------
C     NAMED-NUMBERED-STORAGE                                            
C                                                                       
C     2/3/75 - S. PIEPER                                                
C     11/7/75 - STORE NAME IN COMMON FOR IALLOC ERROR MESSAGES.         
C     4/25/78 - CRAY VERSION WITH NO ENTRIES - S.P.                     
C     12/28/79 - STANDARD MORTRAN - RPG                                 
C     1/16/80 - CHARACTER*8 THENAM - RPG                                
C     2/25/80 - USE MORTRAN MACRO  USAGE  - RPG                         
C     6/13/80 - CHAR*8 NAME FOR CDC - S.P.                              
C     7/14/80 - CRAY VERSION #2 -- MUCH CLOSER TO IBM - S.P.            
C                                                                       
C     USE AS                                                            
C                                                                       
C     1)   ILOC = NALLOC( IWRDS, 'NAME' )                               
C       WHERE ILOC WILL BE AS IS RETURNED FROM IALLOC.  'NAME'          
C       (WHICH NEED NOT BE ON AN 8-BYTE BOUNDRY) IS A NAME THAT WILL    
C       BE ASSOCIATED WITH THE ILOC'TH LOCATION IN THE QUERY STACK.     
C       IF 'NAME' IS ALREADY IN THE QUERY STACK THEN IT WILL BE FREED   
C       AND AN ATTEMPT MADE TO REUSE THE SPACE.  IN THIS CASE IALLOC    
C       IS NOT CALLED.                                                  
C     2)   ILOC = NAMLOC( 'NAME' )                                      
C       RETURNS THE QUERY STACK LOCATION OF AN ALREADY DEFINED NAME.    
C       IF 'NAME' IS NOT IN THE QUERY STACK AS A NON-FREED ELEMENT,     
C       THEN 0 IS RETURNED.                                             
C                                                                       
      IMPLICIT REAL*8 (A-H, O-Z)                                        
C                                                                       
      CHARACTER*1 NAME(8)                                               
CWD      CHARACTER*8 NAME                                               
C                                                                       
      CHARACTER*8 NAMES                                                 
      COMMON /NAMCOM/ NAMES(100)
      COMMON /LOCKT/ L(100)
      COMMON /LENGTH/ LENG(100)
C                                                                       
      LOGICAL NSPTSW                                                    
      COMMON/USAGE/IBASE, NWORDS, IMAX, INAME, IGOT, NLOC, IPEAK, NAMPEK
     *, NUMCOM, ICHEC, THENAM, IWASAT, NAMLC2, NSPTSW                   
C                                                                       
      LOGICAL FNDSW 
      CHARACTER*8 BLANK, THENAM 
	DATA BLANK/' '/
C                                                                       
      CHARACTER*1 NAME1(8), BLNK1                                       
	DATA BLNK1/' '/
      CHARACTER*8 NAME8                                                 
      EQUIVALENCE (NAME8, NAME1(1))                                     
C                                                                       
C     IS IT DEFINED                                                     
C                                                                       
      ASSIGN 100 TO IGO  
      GO TO 800                                                         
 100  IF ( .NOT. FNDSW ) GO TO 150                                      
C
C     FOUND - FREE IT AND TRY TO REUSE                                  
C                                                                       
      L(IL) = IABS(L(IL))                                               
      IF ( L(IL) .EQ. IWRDS ) GOTO 180                                  
      L(IL) = -L(IL)                                                    
      NAMES(IL) = BLANK                                                 
C                                                                       
 150  THENAM = NAME8                                                    
C      print 1919, iwrds, name8
      IL = IALLOC(IWRDS)                                                
C      print 1920, il, l(il)
C1919  format (x,I15,3x,A8)
C1920  format (2I15)
      THENAM = BLANK
      IF ( IL .EQ. 0 ) GO TO 200
 180  NAMES(IL) = NAME8                                                 
 200  NALLOC = IL                                                       
      RETURN                                                            
C
C     LOCATE A NAME                                                     
C
      ENTRY NAMLOC ( NAME )                                             
      assign 300 to igo 
      GO TO 800                                                         
 300  NALLOC = 0                                                        
      IF ( .NOT. FNDSW ) RETURN                                         
      IF ( L(IL) .LT. 0 ) RETURN                                        
      NALLOC = IL                                                       
      RETURN                                                            
C
C     SEARCH FOR A NAME, GET THE NAME FROM THE ARGUMENT LIST            
C
 800  FNDSW = .FALSE.                                                   
      IL = 0                                                            
CWD      NAME8 = NAME                                                   
C
C     PAD IT OUT WITH BLANKS FOR IBM ETC.                               
C
      NAME8 = BLANK                                                     
      DO 809 I = 1, 8                                                   
      NAME1(I) = NAME(I)                                                
      IF (NAME1(I) .EQ. BLNK1 ) GO TO 810                               
 809  CONTINUE                                                          
C
 810  DO 839 I = 1, IMAX                                                
      IF ( NAMES(I) .NE. NAME8 ) GO TO 839                              
      IF ( L(I) .GT. 0 ) GO TO 850                                      
C     SEMI FOUND - PERHAPS THERE IS A BETTER ENTRY                      
      NAMES(I) = BLANK                                                  
      IL = I                                                            
      FNDSW = .TRUE.                                                    
 839  CONTINUE                                                          
      GO TO 870                                                         
C
C     REALLY FOUND                                                      
 850  IL = I                                                            
      FNDSW = .TRUE.                                                    
 870  GO TO IGO                                          
C
      END                                                               
C-----------------------------------------------------------------------
      FUNCTION IALLOC(IWRDS)                                            
C
C     THIS IS THE ENTIRE NUMBERED STORAGE PACKAGE                       
C-----------------------------------------------------------------------
C  THIS ROUTINE ASSIGNS SPACE IN THE ALLOCATED REGION WHICH BEGINS      
C  AT ALLOC(IBASE) AND EXTENDS TO ALLOC(IBASE+NWORDS)                   
C                                                                       
C  THE ALLOCATED ARRAY IS LABELED BY A NUMBER- RETURNED AS THE          
C  FUNCTIONAL VALUE FROM IALLOC                                         
C                                                                       
C  SPACE IS ASSIGNED TO UP TO NAMDIM ARRAYS.  EACH ALLOCATION ICREMENTS 
C  THE SCALAR IAM BY 1.  THE LOCATION OF THE FIRST BYTE OF THE ARRAY    
C  IS KEPT IN L(IAM) AND ITS LENGTH (IWRDS) IS SAVED IN LENG(IAM).      
C  AN ARRAY IS FREED FOR FUTURE RE-USE BY THE OPERATION                 
C                L(NUMBER)=-L(NUMBER)                                   
C  WHERE NUMBER IS THE IDENTIFYING ARRAY NUMBER (FUNCTION VALUE OF      
C  IALLOC) AND L IS THE INTEGER*4 ARRAY IN THE LABELED COMMON LOC       
C                                                                       
C  IF ALLOCATION IS IMPOSSIBLE IALLOC RETURNS A FUNCTION VALUE 0        
C     UNLESS IF   STOPSW = .TRUE.  (SEE BELOW)  INWHICH CASE THE JOB IS 
C     TERMINATED WITH AN ERROR TRACE.                                   
C                                                                       
C  TO CHANGE THE MAXIMUM NUMBER OF NAMES RE-COMPILE WITH                
C  COMMON AREAS NAMES,LOC AND LENGTH WITH NEW DIMENSIONS                
C  AND WITH THE NEW SIZE IN THE NAMDIM DATA STATEMENT BELOW.            
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  THIS VERSION 7/14/73    D.GLOECKNER                                  
C     2/3/75 - STOPSW ADDED, NEW STATISTIC IN NSCAT; NSSTAT ENTRY - S.P.
C              ALSO ADD SOME STUFF FOR NAMED-NUMBERED-STORAGE -- ALL    
C              SUCH ADDITIONS CONTAIN A REFERENCE TO "NAMES" OR "BLANK" 
C     2/16/75 - MANY CHANGES - S.P.                                     
C     2/24/75 - FIX BUG IN COMPRESSING (IGOT UNDEFINED) S.P.            
C     8/15/75 - ADD GIVEAL AND CHOPIT ENTRIES D.G.                      
C     11/7/75 - MAKE REFRESHABLE;  STOP FOR =< 0 SIZE.                  
C     6/6/76 - WORD SIZE FACTORS IN ALLOCS                              
C     9/10/76 - ADD IREDEF                                              
C     12/28/76 - FIX BUG IN ABOVE                                       
C     4/17/77 - ALLOW OVERLAYS BETWEEN GIVEAL AND CHOPIT                
C     5/10/77 - FIX GIVEAL BUG WHEN NAMESTACK IS FULL                   
C     6/11/77 - FIX COMPRESS BUG WHEN IT IS ALREADY COMPRESSED.         
C     1/25/78 - FIX BUG FOR EXACT FIT COMPRESS.                         
C     4/25/78 - NO ENTRIES FOR CRAY VERSION - S.P.                      
C     4/26/78 - PRINT DIAGNOSTICS BASED ON NSPTSW - S.P.                
C     7/3/78 - AVOID CDC OVERFLOW ON INTEGRETIY HCHECK                  
C     7/24/79 - NEW NSDUMP MADE A SEPARATE SUBROUTINE - S.P.            
C     11/4/79 - INCREASE TO 100 NAMES - S.P.                            
C     12/31/79 - STANDARD MORTRAN; CVA, CUN VERSIONS - RPG              
C     1/24/80 - CHARACTER*8 THENAM; LIB%STOP FOR CVA; CORRECT URWALK    
C        FOR CUN; 9950 TO 9550; NAMLCA (NOT NAMLOC) ARG TO IREDEF - RPG 
C     6/15/80 - CORRECT BOB'S IREDEF FIX FOR CDC - S.P.                 
C     7/14/80 - CRAY #2 VERSION -- MUCH CLOSER TO IBM FORTRAN - S.P.    
C     7/23/80 - CRAY VERSION CAN ALOS HAVE EXPANDING ALLOCATOR - S.P.   
C     7/28/80 - ALOW COMPRESS LOOP TO VECTORIZE - S.P.                  
C                                                                       
      IMPLICIT REAL*8 ( A-H, O-Z )                                      
      INTEGER PROBLM, R0TYPE, CONVRG                                    
      COMMON /SWITCH/IASYMP,ICHECK,IECHO,IELAST,IFIT,IVRTEX,IRLWAV, 
     * ITSO,LINEAR,NUCONL,NEXT,IFITER,IEPOW,ISAVMX,ISAVB,LABANG, 
     * PROBLM,MASTYP,R0TYPE,IBSPAS,ISW1,ISW2,ISW3,ISCRFL,NOBFAC, 
     * CONVRG,IEXTYP,IBRNSB,MEORD,KFRMTP,IWRTWV,LORNTZ,IRELPT,ISAVSM                                                            
C                                                                       
      INTEGER GIVEAL, CHOPIT                                            
C                                                                       
      DATA NAMDIM /100/                                                 
      COMMON/LOCKT/L(100)                                                 
      COMMON /LENGTH/ LENG(100)                                         
      CHARACTER*8 NAMES
      COMMON /NAMCOM/ NAMES(100)                                        
C                                                                       
C     FOLLOWING COMMON CONTROLS NUMBERED STORAGE                        
C                                                                       
C     IBASE - OFFSET (IN 8-BYTE WORDS) TO START OF ALLOCATOR            
C     NWORDS - NUMBER OF 8-BYTE WORDS ASSIGNED TO ALLOCATOR.            
C     IMAX - SIZE OF NAME STACK                                         
C     INAME - HIGHEST LOCATION REACHED IN NAME STACK                    
C     IGOT - CURRENT NUMBER OF "ACTIVE" SLOTS IN NAME STACK             
C     NLOC - FIRST FREE WORD AT END OF ALLOCATOR                        
C     IPEAK - PEAK ACTUALLY USED SPACE IN UNITS OF 8-BYTES.             
C     NAMPEK - PEAK NUMBER OF NAMES ACTUALLY IN USE.                    
C     NUMCOM - NUMBER OF COMPRESSES THAT HAVE OCCURED.                  
C     ICHEC - ADDRESS (IN 8-BYTE WORDS) OF END OF ALLOCATOR.            
C     THENAM - NAME OF OBJECT BEING ALLOCATED (SET BY NALLOC).          
C     IWASAT - GIVEAL OBJECT LOCATION                                   
C     NAMLC2 - GIVEAL NAME STACK LOCATION                               
C                                                                       
      LOGICAL NSPTSW                                                    
      COMMON/USAGE/IBASE,NWORDS,IMAX,INAME,IGOT,NLOC,IPEAK,NAMPEK,
     * NUMCOM,ICHEC,THENAM,IWASAT,NAMLC2,NSPTSW                   
C                                                                       
C     STRUCTURE OF EACH ITEM IN THE ALLOCATOR IS                        
C                                                                       
C     WORD         IBM ETC.           CDC ETC.                          
C       1  NNNN 0000 FFFF 0000    00000 NNNNN                           
C     2,3..        DATA               DATA                              
C                                                                       
C             WORD = 8 BYTES       WORD = 60 BITS                       
C     IN BOTH CASES NNNN = NUMBER OF OBJECT (USED FOR VALIDITY          
C     CHECKS).  IN IBM THE HEXADECIMAL STRUCTURE IS SHOWN;              
C     IN THE CDC THE NUMBER IS JUST A FULL-WORD INTEGER.                
C                                                                       
      INTEGER FACFR4, FACFR2, FACFR1                                    
      COMMON/ALLOCS/ FACFR4, FACFR2, FACFR1                             
      DIMENSION ALLOC(1)
      INTEGER*2 LLOC(1)                                                 
      EQUIVALENCE ( FACFR4, ALLOC(1),LLOC(1))                           
CDC      ALLOCLEVEL ALLOC, LLOC, FACFR4, FACFR2, FACFR1                 
C                                                                       
CIB      REAL*8  ANAME / Z 0000 0000 FFFF 0000 /                        
CUN      REAL*4 ANAME4(2) / O000000000000, O777777000000 /              
CUN      EQUIVALENCE  ( ANAME4(1), ANAME )                              
      REAL*8 ANAME                                                      
      DATA ANAME / '00000000FFFF0000'X /                                
      INTEGER*2 NUMBER(4)                                               
      EQUIVALENCE(NUMBER(1),ANAME)                                      
C                                                                       
      LOGICAL STOPSW, REDFSW                                            
      LOGICAL ERRSW, PRTSW, FONDSW, ALLSW                               
      CHARACTER*8 BLANK, THENAM                                         
      DATA STOPSW / .TRUE. /                                            
      DATA BLANK / ' ' /                                                
C          
      REDFSW = .FALSE.                                                  
      IF ( NSPTSW ) WRITE(6,3) THENAM, IWRDS                              
  3   FORMAT ( ' IALLOC/NALLOC: ', A8, I15 )                            
C                                                                       
  5   IF(IWRDS.GT.0)GO TO 100                                           
      WRITE(6,13) THENAM, IWRDS                                           
 13   FORMAT('0**** ', A8, '  - REQUEST FOR ', I15, ' WORDS. ****')     
      GO TO 9500                                                        
C                                                                       
C     PREPARE TO ALLOCATE AN OBJECT.                                    
C     FIRST GO THROUGH THE LIST AND FIND USED SPACE AND NUMBERS.        
C     DURING THIS PASS WE ACCUMULATE INFO FOR STATISTICAL PURPOSES      
C     AND CHECK THE INTEGRETY OF THE ALLOCATOR.  ALSO WE LOOK FOR AN    
C     EXACT FIT TO A FREED SPOT WHICH WILL BE USED IF FOUND.            
C     WE ALSO LOOK FOR AN AVAILABLE NAME SPOT.                          
C                                                                       
 100  FONDSW = .FALSE.
      NAMUSE = 0                                                        
      LUSE = 0                                                          
      NAMLOC = 0                                                        
      IF ( INAME .EQ. 0 ) GO TO 150                                     
      DO 149 N = 1, INAME                                               
C                                                                       
C     IS THIS AN EMPTY SLOT                                             
C                                                                       
      IF (L(N) .NE. 0) GO TO 120                                        
      IF ( NAMLOC .EQ. 0 ) NAMLOC = N                                   
      GO TO 149                                                         
C                                                                       
C     IT IS IN USE OR IS A FREED SPOT.  CHECK INTEGRETY                 
C                                                                       
 120  NUMBER(1) = N                                                     
      GO TO 130            
CK----The following original command is NOT acceptable by ALPHA-------------
CK    if(alloc(iabs(l(n))-1).eq.aname)go to 130
CDC      IF ( LLOC(IABS(L(N))-1) .EQ. NUMBER(1) )  GO TO 130            
CK      PRINT 123, N,L(N),LENG(N),NAMES(N),L(N-1),LENG(N-1),NAMES(N-1)
CK 123  FORMAT ('0*** HEADER OF OBJECT', I4, ' HAS BEEN DESTROYED.' /  ' T
CK     *HIS AND PREVIOUS OBJECT LOCATION, LENGTH AND NAME ARE:' /  ( 2I15,
CK     * 2X, A8 ) )                                                       
C---------------------------------------------------------------------------
C     IS IT FREE SPACE OR A STILL IN USE OBJECT                         
C                                                                       
 130  IF ( L(N) .LT. 0 ) GO TO 140
      NAMUSE = NAMUSE + 1                                               
      LUSE = LUSE + LENG(N) + 1                                         
      GO TO 149                                                         
C                                                                       
 140  IF (FONDSW) GO TO 149                                             
      IF ( IWRDS .NE. LENG(N) ) GO TO 149                               
      NAMLOC = N                                                        
      ILOC = -L(NAMLOC) - 1                                             
      FONDSW = .TRUE.                                                   
C                                                                       
 149  CONTINUE                                                          
C                                                                       
C     SOME STATISTICS                                                   
C                                                                       
 150  IPEAK = MAX0( IPEAK, LUSE+IWRDS+1 )                               
      NAMPEK = MAX0( NAMPEK, NAMUSE+1 )                                 
C                                                                       
C     DID WE FIND AN EXACT FIT                                          
C                                                                       
      IF ( FONDSW ) GO TO 250                                           
C                                                                       
C     NO, DID WE ATLEAST FIND A NAME SLOT                               
C                                                                       
      IF ( NAMLOC .NE. 0 ) GO TO 200                                    
C                                                                       
C     NO, WE MUST GET A NEW NAME SLOT IF THERE ARE MORE AVAILABLE       
C                                                                       
      IF(INAME.LT.IMAX)GO TO 170                                        
C                                                                       
C     WE HAVE GONE THROUGH THE WHOLE STACK OF NAMES, ARE THERE HOLES    
C                                                                       
      IF ( NAMUSE .LT. IMAX ) GO TO 200                                 
 160  WRITE(6,163) THENAM                                                 
 163  FORMAT ('0*** ', A8, 2X, '-- NO MORE NAME SLOTS AVAILABLE ***')   
      GO TO 9500                                                        
C                                                                       
C     ADD TO END OF NAME LIST                                           
C                                                                       
 170  INAME = INAME + 1                                                 
      NAMLOC = INAME                                                    
C                                                                       
C     IS THERE SPACE AT THE END OF THE ALLOCATOR                        
C                                                                       
 200  IF ( NLOC+IWRDS .LE. ICHEC ) GO TO 220                            
C                                                                       
C     NO, WILL COMPRESSION SOLVE IT                                     
C                                                                       
      IF ( LUSE+IWRDS .LT. NWORDS ) GO TO 500                           
CNVC                                                                    
CNVC     ON CDC & CRAY ATTEMPT TO EXPAND THE ALLOCATOR                  
CNVC                                                                    
CNV      NNEED = LUSE + IWRDS + 1                                       
CNV      NASK  = MAX0( NNEED, LUSE+10000 )                              
CNV      CALL GRAB ( ALLOC, FACFR1, IBASE, NASK )                       
CNV      IF ( NASK .LT. NNEED ) GO TO 210                               
CNV      NWORDS = NASK                                                  
CNV      ICHEC = IBASE + NWORDS - 1                                     
CNV      GO TO 100                                                      
C                                                                       
 210  WRITE(6,213) THENAM, IWRDS, IPEAK                                   
213   FORMAT (' *** ', A8, 2X, '-- NOT ENOUGH ALLOCATOR.  ATTEMPTING',  
     *' TO DEFINE A', I12, ' WORD OBJECT.' /  5X, 'TOTAL ALLOCATOR SIZE 
     *MUST BE AT LEAST', I13, ' WORDS.' )                              
      GO TO 9500                                                        
C                                                                       
C     THERE IS ROOM TO ALLOCATE AND ALSO A NAME SLOT IS AVAILABLE.      
C     IF NAMLOC IS NOT YET ASSIGNED THEN WE MUST COMPRESS TO GET THE    
C     SLOT.                                                             
C                                                                       
 220  IF ( NAMLOC .EQ. 0 ) GO TO 500                                    
      ILOC = NLOC                                                       
      NLOC = NLOC + IWRDS + 1                                           
      IGOT = IGOT + 1                                                   
C                                                                       
C     DEFINE THE OBJECT                                                 
C                                                                       
 250  IF ( NSPTSW ) WRITE(6,253) NAMLOC, ILOC, NLOC                       
 253  FORMAT ( ' ASSIGNED', I4, I12, 5X, 'NLOC =', I12 )                
C                                                                       
      L(NAMLOC)=ILOC+1                                                  
C                                                                       
C  PUT NAME (NUMBER) IN FIRST INTEGER*2 PART OF ARRAY                   
C                                                                       
      NUMBER(1)=NAMLOC                                                  
      ALLOC(ILOC)=aname
      LENG(NAMLOC)=IWRDS                                                
      NAMES(NAMLOC) = BLANK                                             
      IALLOC=NAMLOC                                                     
      NAMLC2 = NAMLOC                                                   
      IF ( REDFSW ) GO TO 620                                           
      RETURN
      ENTRY GIVEAL(IWRDS)                                               
C                                                                       
C  COMPRESS THE ALLOCATOR AND                                        
C  GIVE LARGEST CONTIGUOUS PIECE FROM TOP OF ALLOCATOR TO END           
C  RETURNS NUMBER OF WORDS YOU GOT                                      
C  A CALL TO THIS ENTRY SHOULD BE IMMEDIATELY FOLLOWED WITH A CALL TO   
C  CHOPIT                                                               
C                                                                       
      IF ( NSPTSW ) WRITE(6,303)
 303  FORMAT ( ' GIVEAL CALLED' )                                       
      REDFSW = .FALSE.                                                  
      ALLSW = .TRUE.                                                    
      IF ( NLOC .GT. IBASE ) GO TO 505                                  
 300  IWRDS=ICHEC-NLOC-2                                                
      IWASAT=NLOC                                                       
      IF ( IWRDS .GE. 2 ) GO TO 310                                     
      WRITE(6,301)                                                      
301   FORMAT(' ***ERROR/NOTHING TO GIVE IN GIVEAL  CALL')               
      GO TO 9500                                                        
C                                                                       
C     FIND A NAME STACK LOCATION FOR GIVEAL                             
C                                                                       
 310  IF ( INAME .EQ. 0 ) GO TO 170                                     
      DO 304 N = 1, INAME                                               
      IF ( L(N) .NE. 0 ) GO TO 304                                      
      NAMLOC = N                                                        
      GO TO 200                                                         
 304  CONTINUE                                                          
      IF ( INAME .LT. IMAX ) GO TO 170                                  
      GO TO 160                                                         
C                                                                       
      ENTRY CHOPIT(IWRDS)                                               
C                                                                       
C                                                                       
C  THIS CALL MUST FOLLOW GIVEAL--IT TRUNCATES N.STORAGE OBJECT          
C                                                                       
C  PASS NUMBER OF WORDS YOU REALLY WANT                                 
C  CHECK IF THIS CALL IMMEDIATELY FOLLOWS GIVEAL                        
C                                                                       
      IF ( NSPTSW ) WRITE(6,323) IWRDS                                    
 323  FORMAT ( ' CHOPIT CALLED:', I15 )                                 
      ANAME=ALLOC(IWASAT)                                               
      IHAD=number(1)
      IPEAK=IPEAK+IWRDS+1                                               
      IF(NAMLC2.NE.IHAD)GO TO 320                                       
      NAMPEK=NAMPEK+1                                                   
      NLOC=IWASAT+IWRDS+1                                               
      LENG(NAMLC2)=IWRDS                                                
      RETURN                                                            
320   WRITE (6,321)                                                     
321   FORMAT(' ***ERROR CALL TO CHOPIT MUST IMMEDIATELY FOLLOW GIVEAL') 
      GO TO 9500                                                        
C                                                                       
C     COMPRESSION IS NECESSARY AND IT WILL SOLVE OUR PROBLEMS           
C     OR                                                                
C     GIVEAL HAS BEEN CALLED AND WE WANT TO GET THE MOST POSSIBLE       
C                                                                       
C                                                                       
C  THIS SECTION FOR COMPRESSION                                         
C                                                                       
C                                                                       
 500  ALLSW = .FALSE.                                                   
C                                                                       
      IF ( NAMLOC .NE. 0 ) WRITE(6,7432) THENAM                         
7432  FORMAT( X, A8, '  --  COMPRESSION IS OCCURING NOW.' )          
      IF ( NAMLOC .EQ. 0 ) WRITE(6,7433) THENAM                           
7433  FORMAT( X, A8, '  --  NAME STACK COMPRESSION IS OCCURING NOW.' 
     * )                                                                
C                                                                       
 505  LL=IBASE                                                          
      LCNT=0                                                            
      LSUM = 0                                                          
      NUMCOM = NUMCOM + 1                                               
C                                                                       
C     FIND FIRST FREE OBJECT                                            
C                                                                       
 510  LLOW = LL                                                         
      IF ( LCNT .GE. IGOT ) GO TO 600                                   
C                                                                       
      ANAME=ALLOC(LL)                                                   
C                                                                       
C  NEGATIVE LOCATION INDICATES A FREE LOCATION                          
C                                                                       
C  STRUCTURE CHECK                                                      
      NAMLOC = number(1)
      IF(IABS(L(NAMLOC)).NE.(LL+1))GO TO 8171                           
      IF(L(NAMLOC).LT.0)GO TO 520                                       
      LL=LL+LENG(NAMLOC)+1                                              
      LCNT=LCNT+1                                                       
      GO TO 510                                                         
8171  WRITE(6,7170)LL, ANAME, NAMLOC, LENG(NAMLOC), L(NAMLOC), NAMES(NA
     *MLOC)                                                             
7170  FORMAT(' **** STRUCTURE CHECK: LOC, HEADER, NAMLOC, LENG, L,',   
     *'NAME:',  / I13, Z18, 3I13, 2X, A8 )                               
CDC     1  I8, O22, I5, 2I13, 2X, A8 )                                  
      GO TO 9500                                                        
C                                                                       
C     FIRST FREE LOCATION FOUND                                         
C                                                                       
C  LOWEST FREE LOCATION IS AT LLOW-- CORRESPONDING TO THE ARRAY NUMBER  
C  NAMLOC... THE LCNT(TH) ONE UP FROM THE BOTTOM OF THE ALLOCATOR       
C                                                                       
 520  IHCNT=LCNT                                                        
C                                                                       
C     HAVE FOUND A FREE LOCATION.  MARK IT NOT IN USE AND GO ON.        
C                                                                       
 530  L(NAMLOC)=0                                                       
      LSUM = LSUM + LENG(NAMLOC) + 1                                    
C                                                                       
C  HAVE FOUND FIRST FREE LOCATION--NOW FIND NEXT FILLED ONE             
C                                                                       
 540  IF(IHCNT.GE.(IGOT-1))GO TO 600                                    
      IHCNT=IHCNT+1                                                     
      LL=LL+LENG(NAMLOC)+1                                              
      IF(LL.GE.NLOC)GO TO 600                                           
      ANAME=ALLOC(LL)                                                   
      NAMLOC = number(1)
C                                                                       
C  INTERNAL STRUCTURE CHECK                                             
C                                                                       
      IF(IABS(L(NAMLOC)).NE.(LL+1))GO TO 8171                           
      IF(L(NAMLOC).LT.0)GO TO 530                                       
C                                                                       
C     FOUND A STILL-IN-USE OBJECT, COMPRESS                             
C                                                                       
      N=LENG(NAMLOC)+1                                                  
CRACDIR$ IVDEP                                                          
      DO 579 I=1,N                                                      
579   ALLOC(LLOW+I-1)=ALLOC(LL+I-1)                                     
C                                                                       
C  NOTE WE HAVE ALSO MOVED THE IDENTIFYING NUMBER                       
C                                                                       
      LCNT=LCNT+1                                                       
      L(NAMLOC)=LLOW+1                                                  
      LLOW = LLOW+N                                                     
      GO TO 540                                                         
C                                                                       
C     COMPRESS ALL DONE.  UPDATE NUMBER OF ACTIVE SLOTS AND TOP         
C     OF ALLOCATOR "IN USE".                                            
C                                                                       
 600  IGOT=LCNT                                                         
      NLOC = LLOW                                                       
      IF ( ALLSW ) GO TO 300                                            
C                                                                       
      WRITE(6,5101)IGOT, LSUM                                           
5101  FORMAT(' ',I5,' ARRAYS COMPRESSED', I8, ' WORDS FREED' / )        
      GO TO 100                                                         
C                                                                       
C     CALL IREDEF ( NEWSIZE, NUMBER )   REDEFINES THE LENGTH            
C     OF AN EXISTING OBJECT AND DUPLICATES THE EXISTING INFORMATION     
C     INTO IT.  THE NUMBER AND NAME ARE NOT CHANGED BUT THE             
C     LOCATION IN THE ALLOCATOR IS CHANGED.  SPACE MUST BE              
C     AVAILABLE TO MAKE A TEMPORARY DUPLICATE COPY (EVEN FRO            
C     REDUCTIONS IN THE SIZE OF AN OBJECT).                             
C                                                                       
      ENTRY IREDEF ( IWRDS, NAMLCA )                                    
C                                                                       
CDC      ENTRY  IREDF2 ( IWRDS )                                        
CDC      NAMLCA = MOD( IWRDS, 256 )                                     
CDC      IWRDS = IWRDS/256                                              
C                                                                       
      NAMLOC = NAMLCA                                                   
      NAMOLD = NAMLOC                                                   
      THENAM = NAMES(NAMOLD)                                            
      IF ( NSPTSW ) WRITE(6,613) THENAM, IWRDS                            
 613  FORMAT ( ' IREDEF: ', A8, I15 )                                   
      IWDOLD = LENG(NAMOLD)                                             
      REDFSW = .TRUE.                                                   
      GO TO 5                                                           
C                                                                       
C     COPY OLD TO NEW INCLUDING HEADER                                  
C                                                                       
 620  N = MIN0( IWRDS, IWDOLD ) + 1                                     
      LL = L(NAMOLD) - 1                                                
      DO 629 I = 1, N                                                   
      ALLOC(ILOC-1+I) = ALLOC(LL-1+I)                                   
 629  CONTINUE                                                          
C                                                                       
C     CHANGE OLD TO POINT TO NEW                                        
C                                                                       
      L(NAMOLD) = ILOC+1                                                
      LENG(NAMOLD) = IWRDS                                              
      NAMES(NAMOLD) = THENAM                                            
C                                                                       
C     CHANGE NEW TO POINT TO OLD AND FREE IT                            
C                                                                       
      ALLOC(LL) = ANAME                                                 
      LENG(NAMLOC) = IWDOLD                                             
      L(NAMLOC) = -(LL+1)                                               
      IALLOC = NAMOLD                                                   
      NAMLOC = NAMOLD                                                   
C                                                                       
      RETURN                                                            
C                                                                       
      ENTRY ISTART(NBYTES)                                              
CDC      NBYTES = IWRDS                                                 
C                                                                       
C  INITIALIZE ALLOCATION                                                
C                                                                       
C     THE INPUT IS THE NUMBER OF BYTES TO ALLOCATE, OR IF NEGATIVE, THE 
C     NUMBER OF BYTES TO LEAVE FREE.                                    
C                                                                       
      NUMCOM = 0                                                        
      FACFR4 = 2                                                        
      FACFR2 = 4                                                        
      FACFR1 = 8                                                        
CDC      FACFR4 = 1                                                     
CDC      FACFR2 = 1                                                     
CDC      FACFR1 = 1                                                     
CRA      FACFR4 = 1                                                     
CRA      FACFR2 = 1                                                     
CRA      FACFR1 = 1                                                     
C                                                                       
      NWORDS = NBYTES                                                   
      CALL GRAB(ALLOC,FACFR1,IBASE,NWORDS)                              
      ICHEC=IBASE+NWORDS-1                                              
C                                                                       
C  ALLOC(IBASE) IS FIRST BYTE OF ALLOCATED AREA--- ALLOC(IBASE+NWORDS)  
C  IS LAST BYTE                                                         
C                                                                       
      IMAX= NAMDIM                                                      
      IPEAK = 0                                                         
      NAMPEK = 0                                                        
      NUMCOM = 0                                                        
C                                                                       
 710  NLOC = IBASE                                                      
      INAME = 0                                                         
      IGOT = 0                                                          
      THENAM = BLANK                                                    
      DO 719 I=1, IMAX                                                  
      NAMES(I) = BLANK                                                  
719   L(I)=0                                                            
C                                                                       
      IF ( NSPTSW ) WRITE(6,723) IBASE, ICHEC, IMAX                       
 723  FORMAT ( ' ALLOCATOR RANGE:', 2I12, 5X, '# NAMES =', I5 )         
      IALLOC=IBASE                                                      
      RETURN                                                            
C                                                                       
      ENTRY ICLEAR(IDUM)                                                
C                                                                       
C  THIS ENTRY CLEARS ALL DATA                                           
C                                                                       
      WRITE(6,8429)                                                     
 8429 FORMAT(/'   -------  ALL NUMBERED OBJECTS CLEARED  ------'/)      
      GO TO 710                                                         
C                                                                       
C     NSSTAT  PRINTS NUMBERED STORAGE STATISTICS                        
C                                                                       
      ENTRY NSSTAT (IDUM)                                               
      PRTSW = .FALSE.                                                   
      ALLSW = .FALSE.                                                   
      GO TO 900                                                         
C                                                                       
C  NSCAT GIVES A LISTING OF NUMBERED OBJECT,THEIR LENGTHS AND LOCATIONS 
C                                                                       
C     IF  IDUM = -1  THEN FREE AREAS ARE ALSO LISTED                    
C                                                                       
C                                                                       
      ENTRY NSCAT(IDUM)                                                 
C                                                                       
CDC      IDUM = IWRDS                                                   
C                                                                       
      PRTSW = .TRUE.                                                    
      ALLSW = IDUM .EQ. -1                                              
 900  ERRSW = .FALSE.                                                   
C                                                                       
 910  LUSE = 0                                                          
      NAMUSE = 0                                                        
C                                                                       
      IF (PRTSW) WRITE(6,923 )                                          
923   FORMAT ( '             ---- NUMBERED STORAGE CATALOG ----' )      
      IF ( NSPTSW .OR. PRTSW .AND. ALLSW ) WRITE(6,924) IBASE,NLOC, 
     *ICHEC,IGOT
 924  FORMAT ('     FROM', I8, 3X, 'TO', I8, 6X,  'TOP OF ALLOC =', I8,
     * I8, ' ACTIVE NAME SLOTS' )                                       
      IF ( PRTSW ) WRITE(6,927)
 927  FORMAT ('         NUMBER   NAME     LENGTH     START     END')   
      DO 949 III=1,INAME                                                
      LLOW = IABS(L(III))                                               
      LL = LLOW + LENG(III)+1                                           
      IF(L(III).LE.0)GO TO 940                                          
      LUSE = LUSE + LENG(III) + 1                                       
      NAMUSE = NAMUSE + 1                                               
      IF (PRTSW) WRITE(6, 933)III, NAMES(III), LENG(III), LLOW, LL      
 933  FORMAT(' ', 4X, I10, 2X, A8, I8, I10, I8 )                        
      GO TO 949                                                         
 940  IF ( ALLSW .AND. LLOW .GT. 0 ) WRITE(6,943) III,NAMES(III),  
     *LENG(III), LLOW, LL                                                     
 943  FORMAT(' ', 4X, I10, 2X, A8, I8, I10, I8, 5X, 'FREED' )           
 949  CONTINUE                                                          
C                                                                       
      LSIZE = NLOC - IBASE                                              
      BSIZE = LSIZE/128.                                                
      BAVAIL = NWORDS/128.                                              
      BUSE = LUSE/128.                                                  
      BPEAK = IPEAK/128.                                                
      WRITE(6,5427) NWORDS,BAVAIL,LSIZE,BSIZE,LUSE,BUSE,IPEAK,BPEAK, 
     *IMAX, INAME, NAMUSE, NAMPEK, NUMCOM                            
 5427 FORMAT ( X, T17, 'ALLOCATOR STATISTICS' /  T41, 'WORDS   KILOBYT
     *ES' /  ' ALLOCATOR SIZE:', T38, I8, F10.1 /  ' CURRENT UNCOMPRESSE
     *D SIZE:', T38, I8, F10.1 /  ' CURRENT COMPRESSED SIZE:', T38, I8, 
     *F10.1 /  ' PEAK COMPRESSED SIZE:', T38, I8, F10.1 /  ' NAME STACK 
     *SIZE:', T38, I8 /  ' CURRENT HIGHEST NAME:', T38, I8 /  ' CURRENT 
     *NAMES IN USE:', T38, I8 /  ' PEAK NAMES IN USE:', T38, I8 /  ' NUM
     *BER OF ALLOCATOR COMPRESSES:', T38, I8 //)                        
C                                                                       
      IF (ERRSW) GO TO 9550                                             
C                                                                       
      RETURN                                                            
C                                                                       
C     NO ROOM FOR ALLOCATION, STOP OR RETURN A 0                        
C                                                                       
 9500 IALLOC = 0                                                        
      IF ( .NOT. STOPSW ) RETURN                                        
C                                                                       
      WRITE(6,9503)
 9503 FORMAT (' ****** EXECUTION IS BEING TERMINATED BY NUMBERED',  ' ST
     *ORAGE ******' / )                                                 
      ERRSW = .TRUE.                                                    
      PRTSW = .TRUE.                                                    
      ALLSW = .TRUE.                                                    
      GO TO 910                                                         
CIB 9550 CALL ERRTRA                                                    
CDC 9550 CALL SYSERR                                                    
CRA 9550 CALL TRBK( 101 )                                               
CRA      CALL TRBK                                                      
CUN 9550 CALL URWALK ( 'IALLOC' )                                       
CK 9550 CALL LIB$STOP(%VAL(4))
CK      STOP 1234                                                         

 9550 STOP

CDC      FUNCTION  IREDEF ( IWRDS, NAMLOC )                             
CDC      IREDEF = IREDF2 ( 256*IWRDS + NAMLOC )                         
CDC      RETURN                                                         
      END                                                               

      CHARACTER*8 FUNCTION DATE ( DUM )
      INTEGER*4 JMO,JDAY,JYEAR
      CHARACTER*10 KMO(12)
      DATA KMO/'January','February','March','April',
     & 'May','June','July','August',
     & 'September','October','November','December'/
C                                                                       
C     RETURNS DATE IN FORM MM/DD/YY. 
C                                                                       
      CALL IDATE ( JMO, JDAY, JYEAR )                               
C      WRITE (6,103) JDAY,KMO(JMO),JYEAR                          
C 103  FORMAT (/,' Today is: ',I2,2X,A10,',  19',I2,/ ) 
      RETURN                                                            
      END
      
      CHARACTER*24 FUNCTION FILMAK ( SUBDIR, FIL )                      
C                                                                       
C      BUILDS A COMPLETE VAX/VMS FILENAME.                              
C                                                                       
C      SUBDIR = CHARACTER*8 SUBDIRECTORY (UNDER USER'S DEFAULT          
C         DIRECTORY).                                                   
C     FIL = CHARACTER*8 FILENAME (NOT INCLUDING TYPE .SPK).             
C                                                                       
      CHARACTER*8 SUBDIR, FIL                                           
C                                                                       
      FILMAK = ' '                                                      
      IF ( SUBDIR .NE. ' ' ) FILMAK = SUBDIR             
      FILMAK = FILMAK(1:11) // FIL // '.SPK'                            
C                                                                       
C     SQUEEZE OUT BLANKS.                                               
C                                                                       
      N = 0                                                             
      DO 19 I = 1, 24                                                   
      IF ( FILMAK(I:I) .EQ. ' ' ) GO TO 19                              
      N = N + 1                                                         
      FILMAK(N:N) = FILMAK(I:I)                                         
 19   CONTINUE                                                          
      FILMAK(N+1:24) = ' '                                              
      RETURN                                                            
      END
      
      SUBROUTINE KEEP (ARRAY,KIND,KLAS,NROW,NCOL,MEMBER,DDNAME,IER)
C                                                                       
C      KEEPS A "SPEAKEASY" OBJECT.  VAX/VMS VERSION.                    
C                                                                       
C     ARGUMENTS:                                                        
C                                                                       
C     ARRAY = ARRAY TO BE WRITTEN (ANY TYPE OR LENGTH).                 
C     KIND = VARIABLE TYPE:                                             
C         1 = INTEGER                                                   
C         2 OR 3 = REAL*8                                               
C         4 = COMPLEX*16 ( 2 REAL*8 NUMBERS)                            
C         5 = REAL*4                                                    
C         6 = CHARACTER*8                                               
C         7 = INTEGER*2                                                 
C         8 = INTEGER*1 OR LOGICAL*1                                    
C         9 = CHARACTER*1                                               
C         ANYTHING ELSE = REAL*8                                        
C     KLAS = AN INTEGER, WRITTEN BUT IGNORED.                           
C     NROW = ROW LENGTH (SECOND OR ONLY DIMENSION).                     
C     NCOL = COLUMN LENGTH (FIRST, MOST RAPDLY VARYING DIMENSION).      
C     MEMBER = CHARACTER*8 FILE NAME (TYPE IS .SPK).                    
C     DDNAME = SUBDIRECTORY NAME (UNDER USER'S DEFAULT DIRECTORY).      
C     IER = RETURNED ERROR FLAG:  0 = OK, OTHERWISE IT IS THE FORTRAN   
C         ERROR NUMBER, LISTED IN TABLE B-4 OF THE "VAX-11 FORTRAN      
C         IV-PLUS USER'S GUIDE".                                        
C                                                                       
C          THE OUTPUT FILE CONTAINS TWO RECORDS.  THE FIRST BLOCK HAS   
C     THE MEMBER NAME (REDUNDANT), KIND, CLAS, NROW, NCOL, THE NUMBER OF
C     BYTES WRITTEN, AND THE DATE AND TIME.  THE SECOND RECORD CONTAINS 
C     THE OBJECT ITSELF.  THE FILE IS WRITTEN USING STANDARD UNFORMATTED
C     WRITE STATEMENTS ON LOGICAL UNIT 4.                               
C                                                                       
      LOGICAL*1 ARRAY(1)                                                
      CHARACTER*8 MEMBER, DDNAME                                        
C                                                                       
      INTEGER BYTES(9)                                                  
      DATA BYTES / 4, 8, 8, 16, 4, 8, 2, 1, 1 /                         
      CHARACTER*8 DAT, TIM, DATE                                        
      CHARACTER*24 FILNAM, FILMAK                                       
C                                                                       
      IER = 0                                                           
C                                                                       
C     COMPUTE THE LENGTH OF THE ARRAY IN BYTES.                         
C                                                                       
      IF ( KIND .GT. 0 .AND. KIND .LT. 10 ) THEN                        
      NBYTES = BYTES(KIND)                                              
      ELSE                                                              
      NBYTES = 8                                                        
      END IF                                                            
      NBYTES = NBYTES*MAX0(NROW,1)*MAX0(NCOL,1)                         
C                                                                       
C     CONSTRUCT THE FILENAME, WITH BLANKS SQUEEZED OUT.                 
C                                                                       
      FILNAM = FILMAK( DDNAME, MEMBER )                                 
C                                                                       
C     OPEN THE FILE.                                                    
C                                                                       
      OPEN (UNIT=4,NAME=FILNAM,TYPE='NEW',FORM='UNFORMATTED',ERR=900)
C                                                                       
C     WRITE THE ID RECORD.                                              
C                                                                       
      DAT = DATE( DAT )                                                 
      CALL TIMODA( TIM )                                                
      WRITE (4,ERR=900) MEMBER,KIND,KLAS,NROW,NCOL,NBYTES,DAT,TIM                                                              
C                                                                       
C     WRITE THE ARRAY.  CHARACTER TYPES REQUIRE A DIFFERENT             
C     SUBROUTINE BECAUSE THE ARGUMENT IS PASSED BY DESCRIPTOR.          
C                                                                       
      IF ( KIND .EQ. 6 .OR. KIND .EQ. 9 ) THEN                          
      CALL KEEPCH ( ARRAY, NBYTES, &900 )                               
      ELSE                                                              
      CALL KEEPNM ( ARRAY, NBYTES, &900 )                               
      ENDIF                                                             
C                                                                       
C     CLOSE THE FILE.                                                   
C                                                                       
      CLOSE ( UNIT=4, DISP='SAVE', ERR=900 )                            
      RETURN                                                            
C                                                                       
C     ERROR.  RETURN THE ERROR NUMBER IN IER, AND PRINT THE ERROR MESSAG
C     SEE PAGE 6-27 OF THE "VAX-11 COMMON RUN-TIME PROCEDURE LIBRARY    
C     REFERENCE MANUAL".                                                
C                                                                       
C 900  CALL ERRSNS ( IER, IRMSTS, IRMSTV, ICOND )                        
  900 RETURN                                                            
      END                                                               
C                                                                       
C     THESE SIMPLE SUBROUTINES SPEED UP I/O PROCESSING.                 
C                                                                       
      SUBROUTINE KEEPCH ( ARRAY, N, * )                                 
      CHARACTER*1 ARRAY(N)                                              
      WRITE ( 4, ERR=910 ) ARRAY                                        
      RETURN                                                            
 910  RETURN 1                                                          
      END                                                               
C                                                                       
      SUBROUTINE KEEPNM ( ARRAY, N, * )                                 
      LOGICAL*1 ARRAY(N)                                                
      WRITE ( 4, ERR=920 ) ARRAY                                        
      RETURN                                                            
 920  RETURN 1                                                          
      END                                                               
      SUBROUTINE KEPT ( ARRAY, KIND, KLAS, NROW, NCOL, MEMBER,  DDNAME, 
     *IER, IFLG )                                                       
C                                                                       
C     RETRIEVES A KEPT "SPEAKEASY" OBJECT.  VAX/VMS VERSION.            
C                                                                       
C     THE ARGUMENTS ARE THE SAME AS SUBROUTINE KEEP EXCEPT:             
C                                                                       
C     IFLG = FLAG (INPUT):                                              
C        = 0 TO READ ONLY THE ID RECORD.                                
C        = 1 TO READ THE WHOLE FILE.                                    
C                                                                       
C     ALTERNATE ENTRY POINTS:                                           
C                                                                       
C     CALL KEPTCN ( ARRAY, IER, LEN )                                   
C                                                                       
C        TO CONTINUE READING THE SAME KEPT OBJECT.                      
C        A KEPTCN CALL NORMALLY FOLLOWS A KEPT CALL WITH                
C        IFLG=0.  LEN IS THE NUMBER OF BYTES IN THE RECEIVING ARRAY.    
C                                                                       
C     CALL KEPTCL                                                       
C                                                                       
C        TO CLOSE THE MOST RECENTLY OPENED KEEP FILE.                   
C        KEPTCL SHOULD BE CALLED IF YOU CALL KEPT WITH IFLG=0           
C        AND THEN DECIDE NOT TO CALL KEPTCN.                            
C                                                                       
C          NOTE:  THE RETURN STATUS IER IS ALWAYS THE VAX/VMS FORTRAN   
C     ERROR NUMBER.  THESE ARE NOT THE SAME AS THE IBM ERROR NUMBERS    
C     EXPECTED BY THE PTOLEMY SUBROUTINE GETIT.  HOWEVER, THIS DOESN'T  
C     MATTER BECAUSE THE APPROPRIATE ERROR MESSAGE IS ALWAYS PRINTED    
C     ANYWAY.                                                           
C                                                                       
      LOGICAL*1 ARRAY(1)                                                
      CHARACTER*8 MEMBER, DDNAME, OLDMEM                                
C                                                                       
      CHARACTER*8 DAT, TIM                                              
      CHARACTER*24 FILNAM, FILMAK                                       
C                                                                       
      IER = 0                                                           
C                                                                       
C     CONSTRUCT THE FILENAME, AND OPEN THE FILE.                        
C                                                                       
      FILNAM = FILMAK( DDNAME, MEMBER )                                 
      OPEN (UNIT=4,NAME=FILNAM,TYPE='OLD',FORM='UNFORMATTED',READONLY, 
     * ERR=900 )                                                    
C                                                                       
C     READ THE ID RECORD, AND PRINT INFO.                               
C                                                                       
      READ ( 4, ERR=900 ) OLDMEM,KIND,KLAS,NROW,NCOL,NBYTES,DAT,TIM                                                               
      WRITE(6,1000) OLDMEM, DAT, TIM                                      
 1000 FORMAT ( ' ORIGINAL MEMBERNAME = ', A8, '   WRITTTEN ON ',  A8, ' 
     *AT ', A8 )                                                        
C                                                                       
C     QUIT IF REQUESTED.                                                
C                                                                       
      IF ( IFLG .EQ. 0 ) RETURN                                         
      GO TO 100                                                         
C                                                                       
C     CONTINUE READING                                                  
C                                                                       
      ENTRY KEPTCN ( ARRAY, IER, LEN )                                  
      NBYTES = MIN0 ( LEN, NBYTES )                                     
C                                                                       
 100  IF ( KIND .EQ. 6 .OR. KIND .EQ. 9 ) THEN                          
      CALL KEPTCH ( ARRAY, NBYTES, &900 )                               
      ELSE                                                              
      CALL KEPTNM ( ARRAY, NBYTES, &900 )                               
      END IF                                                            
C                                                                       
C     CLOSE THE FILE.                                                   
C                                                                       
      ENTRY KEPTCL                                                      
C                                                                       
      CLOSE ( UNIT=4 )                                                  
      RETURN                                                            
C                                                                       
C     ERROR.  SIGNAL AND RETURN ERROR NUMBER.                           
C                                                                       
C 900  CALL ERRSNS ( IER, IRMSTS, IRMSTV, ICOND )                        
 900  RETURN                                                            
      END                                                               
C                                                                       
C     THESE SIMPLE SUBROUTINES SPEED UP I/O PROCESSING.                 
C                                                                       
      SUBROUTINE KEPTCH ( ARRAY, N, * )                                 
      CHARACTER*1 ARRAY(N)                                              
      WRITE ( 4, ERR=910 ) ARRAY                                        
      RETURN                                                            
 910  RETURN 1                                                          
      END                                                               
C                                                                       
      SUBROUTINE KEPTNM ( ARRAY, N, * )                                 
      LOGICAL*1 ARRAY(N)                                                
      WRITE ( 4, ERR=920 ) ARRAY                                        
      RETURN                                                            
 920  RETURN 1                                                          
      END
      
      FUNCTION LENHF ( IDUM )                                           
C                                                                       
C     RETURNS THE ESTIMATED LENGTH OF THE SAVEHS FILE (IN BYTES)        
C                                                                       
C     FOR BEST RESULTS, THE FOLLOWING KEYWORDS SHOULD BE SPECIFIED      
C     BEFORE SAVEHS:  VPOLYORD, NPDIF, NPSUM, LMAX, LMIN, LSTEP,        
C     REACTION, AND MULTIPASS.                                          
C                                                                       
      IMPLICIT REAL*8 ( A-H, O-Z )                                      
      COMMON /CNSTNT/ PI, RT4PI, PIINV, RADIAN, DEGREE, HBARC, AMUMEV, 
     & AFINE, BIGEST, SMLEST, BIGNUM, SMLNUM, BIGLOG                      
      INTEGER PARITS, PARIPT, PARITY                                    
      COMMON /INTGER/ L, LMAX, LMIN, LOOKST, LX, MAPSUM, MAPDIF, MAXITR,
     * NAITKN, NBACK, NCOSIN, NODES, NPDIF, NPHIAD, NPPHI, NPSUM, IPRINT
     *, ISIZE, IZS(5), IZP, IZT, LSTEP, LBACK, MAXLEX, LMAXAD, MAXFUN, I
     * REINI, MODEFT, NUMRAN, NVPOLY, NPCOUL, MXCOUL, LMINSB, PARITS(5), 
     * PARIPT(2), PARITY, IPARM1, IPARM2, IPARM3, IPARM4, IPARM5, 
     & NBLKSZ, MAPPHI, NFIROF, LEBACK                                           
      COMMON /JBLOCK/ J, JS(5), JP, JSP, JST, JPARM1, JPARM2, JPARM3    
      INTEGER PROBLM, R0TYPE, CONVRG                                    
      COMMON /SWITCH/ IASYMP, ICHECK, IECHO, IELAST, IFIT, IVRTEX, IRLWA
     *V, ITSO, LINEAR, NUCONL, NEXT, IFITER, IEPOW, ISAVMX, ISAVB, LABAN
     *G, PROBLM, MASTYP, R0TYPE, IBSPAS, ISW1, ISW2, ISW3, ISCRFL, NOBFA
     *C, CONVRG, IEXTYP, IBRNSB, MEORD, KFRMTP, IWRTWV, LORNTZ, IRELPT, 
     * ISAVSM                                                            
      LOGICAL*1 WASSET                                                  
      COMMON /INTRNL/ UNDEF, NOTDEF, ICHANB, ICHANW, ICNTT, EBNDS(2), 
     & IDONE, ISTRIP, IHSAVE, NEXTSV, IPOT, IWFN, LIMOST, IEXCIT, 
     & R0MASS, WASSET(40), RATMAS, LSPECS(4), NODESP(4), LSPCPT(2), 
     & NODEPT(2),ICD3I
C     NBYTE8 AND NBYTE4 ARE THE NUMBER OF BYTES IN REAL*8 NUMBERS AND   
C     INTEGERS RESPECTIVELY.                                            
C                                                                       
      DATA NBYTE8, NBYTE4 / 8, 4 /                                      
C                                                                       
C     THESE ARE THE LENGTHS OF THE DATA-ENTERING COMMONS.  THEY         
C     SHOULD AGREE WITH THE CORRESPONDING VALUES IN  CONTRL,            
C     BUT IT DOESN'T MATTER MUCH IF THEY GET A LITTLE BEHIND.           
C                                                                       
      DATA NUMFLT/151/, NUMINT/51/, NUMJ/12/, NUMSW/23/                 
C                                                                       
C                                                                       
C     RECORD 1 HAS THE HEADER ETC.                                      
C                                                                       
      LENHF = 152 + NBYTE4                                              
C                                                                       
C     EACH OF RECORDS 2-4 HAS THE DATA-ENTERING COMMONS AND SOME        
C     OTHER STUFF.                                                      
C                                                                       
      LENHF = LENHF + NBYTE8*(NUMFLT+7) + NBYTE4*( NUMINT + NUMJ + NUMS
     *W + 6 )                                                           
C                                                                       
C     RECORDS 5 AND 6 ARE WRITTEN BY  GRDSET,  JUST AFTER STATEMENT 950.
C                                                                       
      LENHF = LENHF + NBYTE4*8 + NBYTE8*14                              
      LENHF = LENHF + NBYTE8*( 3*NVPOLY+3 + NPSUM + 3*NPDIF*NPSUM )     
C                                                                       
C     RECORDS 7 AND 8 ARE WRITTEN IN  ANGSET  JUST ATER STATEMENT 1309. 
C     IF LMAX OR LMIN IS UNDEFINED (AS USUAL), WE MUST GUESS THE NUMBER 
C     OF L'S TO BE CALCULATED.  WE USE EXAMPLE 3.                       
C                                                                       
      NL = 10                                                           
      IF ( LMAX .NE. NOTDEF .AND. LMIN .NE. NOTDEF) NL=(LMAX-LMIN+
     & LSTEP)/LSTEP                                                      
      LENHF = LENHF + NBYTE4 + NBYTE4*NL                                
C                                                                       
C     THE REST OF THE RECORDS ARE WRITTEN IN  INELDC  AFTER STATEMENT   
C     549.  THERE IS ONE RECORD FOR EACH (LI,DIF), PLUS ONE.            
C     EACH RECORD CONTAINS AN INTEGER IDENTIFIER, PLUS ONE REAL*8       
C     NUMBER FOR EACH (SUM,LX,LO-LI).  TO CALCULATE THE NUMBER OF LX'S, 
C     THE LOWEST POSSIBLE VALUES OF TRANSFERRED J'S ARE ASSUMED.        
C     IF ANY PARITIES ARE UNKNOWN, NO PARITY CHANGE IS ASSUMED.         
C                                                                       
      JPT = IABS( JS(2) - JS(3) )                                       
      JTT = IABS( JS(1) - JS(4) )                                       
      IPA = ( 1 - PARITS(1)*PARITS(2)*PARITS(3)*PARITS(4) )/2           
      LXF = IABS( JPT - JTT )/2                                         
      LXL = ( JPT + JTT )/2                                             
      N = ( (LXL+LXF+1)*(LXL-LXF+1) + MOD( LXF+IPA+1, 2 ) )/2           
      LENHF = LENHF + ( NL*NPDIF + 1 )*(NBYTE4 + NBYTE8*N*NPSUM )       
C                                                                       
C     IF "MULTIPASS" HAS BEEN SPECIFIED, THE ALLOCATION IS DOUBLED.     
C                                                                       
      IF ( IBSPAS .NE. 0 ) LENHF = 2*LENHF                              
C                                                                       
      RETURN                                                            
      END
      
      SUBROUTINE TIMODA ( THETIM )                                      
C                                                                       
C     RETURNS TIME IN FORM HH:MM:SS.  VAX/VMS VERSION.                  
C                                                                       
C     1/21/80 - RPG                                                     
C                                                                       
      CHARACTER*8 THETIM                                                
      CALL TIME(THETIM)                                     
      RETURN                                                            
      END
      
      SUBROUTINE TOCHAR ( BYTES, CHARS, N )                             
C                                                                       
C     TOCHAR PUTS N BYTES IN CHARACTER STRING, FROMCH DOES OPPOSITE.    
C                                                                       
C     2/25/80 - RPG                                                     
C                                                                       
      LOGICAL*1 BYTES(N)                                                
      CHARACTER*1 CHARS(N)                                              
C                                                                       
      DO 9 I = 1, N                                                     
      CHARS(I) = CHAR(BYTES(I))                                         
 9    CONTINUE                                                          
      RETURN                                                            
C                                                                       
      ENTRY FROMCH ( BYTES, CHARS, N )                                  
C                                                                       
      DO 19 I = 1, N                                                    
      BYTES(I) = ICHAR(CHARS(I))                                        
 19   CONTINUE                                                          
      RETURN                                                            
      END
      
      SUBROUTINE WRITHS ( N, LI, A, * )                                 
C                                                                       
C     WRITHS, READHS:  WRITE & READ H'S AS WHOLE ARRAYS FOR FAST I/O    
C                                                                       
C     2/29/80 - RPG                                                     
C                                                                       
      REAL*8 A(N)                                                       
CDC      ALLOCLEVEL A                                                   
C                                                                       
      WRITE ( 1, ERR=100 ) LI, A                                        
      RETURN                                                            
C                                                                       
      ENTRY READHS ( N, LI, A, * )                                      
C                                                                       
      READ ( 1, ERR=100, END=100 ) LI, A                                
      RETURN                                                            
C                                                                       
 100  RETURN 1                                                          
      END
      
      SUBROUTINE WRITSC ( N, A, B, C, D, * )                            
C                                                                       
C     WRITES AND READS SCRATCH FILE USING WHOLE ARRAYS FOR FAST I/O     
C                                                                       
C     2/29/80 - RPG                                                     
C                                                                       
      REAL*4 A(N), B(N), C(N), D(N)                                     
CDC      ALLOCLEVEL  A, B, C, D                                         
C                                                                       
      WRITE ( 2, ERR=100 ) A, B, C, D                                   
      RETURN                                                            
C                                                                       
      ENTRY READSC ( N, A, B, C, D, * )                                 
C                                                                       
      READ ( 2, ERR=100, END=100 ) A, B, C, D                           
      RETURN                                                            
C                                                                       
 100  RETURN                                                            
      END                                                               

      PROGRAM NFDEC
      IMPLICIT REAL*8 (A-H,O-Z)   
      COMPLEX*16 FCL,FTT,FNR,FFR,SMTR,COUL,QMINU,QPLUS,FACTL
      COMMON/HELP/PLG(500),QLG(500)
      COMMON/HELP1/ETA,PI,SIGMA0,SK,THETAR,FCLR,FCLI 
      DIMENSION SMTR(500),COUL(500),DELTA(500),SABS(500)
      PI = 3.141592653589793238462643D0
      RADF=PI/180.0D0
      open(5,file='SMATR.PLT',form='formatted',status='old') 
      open(6,file='oc115nf.out',form='formatted')
	open(12,file='test.dat',form='formatted')
      READ(5,10)LMIN,LMAX,LSTP,AGMAX,AGSTP,Z12,SM12,SK
c     	write(*,*) LMIN,LMAX,LSTP,AGMAX,AGSTP,Z12,SM12,SK
  10  FORMAT(3I5,5F10.4)
C----Z12=Z1*Z2, SM12 is the reduced mass in MeV/c**2, SK is the wave 
C----number in 1/fm. They can be found in PTOLEMY output.-----------
      ETA=1.43986D0*Z12*SM12/(197.32858D0)**2/SK
      LMI=LMIN+1
      LMA=LMAX+1
      SIGMAR=0.0
      DO 2 L=LMI,LMA,LSTP
      READ(5,20) L1,L2,LX,SR,SI,TEMP,PHASE,PCB,TL     
  20  FORMAT (3I5,G16.8,2X,G16.8,2X,4G15.6)
ccmoj        READ(5,2000) L1,L2,LX,SR,SI,TEMP,PHASE,TL
	write(12,*) L1,L2,LX,SR,SI,TEMP,PHASE,TL
c  20  FORMAT (3I5,G16.8,2X,G16.8,2X,3G15.6)
  22  format(3I5,G16.8,1X,G13.8,3X,3G15.6)
2000  FORMAT (I3,2I5,G17.8,2X,G12.8,3X,G16.10,2X,F10.4,3X,G13.10)
      IF(L1.NE.L-1) THEN
      WRITE(6,30)
      	write(12,2000)L,L1,LMIN,LMAX,LSTP,AGMAX,AGSTP,Z12,SM12,SK 
  30  FORMAT(1X,' CHECK CONSISTENCY IN L-VALUES')
      STOP
      ELSE
      SMTR(L)=DCMPLX(SR,SI)
      SABSL=DSQRT(SR**2+SI**2)
      PHASEN=DATAN2D(SI,SR)
      ETAL=1.0D0-(SR**2+SI**2)
      SIGMAR=SIGMAR+DFLOAT(2*L-1)*ETAL
C----Calculate the point Coulomb phase---------------
      ACOU=2.0D0*SIGMAL(ETA,L-1)
      COUL(L)=DCMPLX(DCOS(ACOU),DSIN(ACOU))
      END IF
C----Check if we get the right input for S-matrix-----
c      write(6,20) L1,L2,LX,SR,SI,SABSL,0.5*phasen,0.5*acou,TL
      SABS(L)=SABSL
   2  DELTA(L)=PHASEN
      NTMAX=NINT(AGMAX/AGSTP)
      SIGMA0=SIGMAL(ETA,0)
      DO 3 NTHETA=1,NTMAX
      THETA=DFLOAT(NTHETA)*AGSTP
      THETAR=RADF*THETA
      X=DCOS(THETAR)
      Z=DSIN(0.5D0*THETAR) 
      IF(LSTP.EQ.1) THEN
C----Calculate Rutherford amplitude-----------------
      FACTR=-ETA/(2.0D0*SK*Z**2)
      ARGC=2.0D0*(SIGMA0-ETA*DLOG(Z))
      FCLR=FACTR*DCOS(ARGC)
      FCLI=FACTR*DSIN(ARGC)
      ELSE
C----Calculate Mott amplitude-----------------------
      Z1=DSIN(0.5D0*(PI-THETAR)) 
      FACTR=-ETA/(2.0D0*SK*Z**2)
      FACTR1=-ETA/(2.0D0*SK*Z1**2)
      ARGC=2.0D0*(SIGMA0-ETA*DLOG(Z))
      ARGC1=2.0D0*(SIGMA0-ETA*DLOG(Z1))
      FCLR=FACTR*DCOS(ARGC)+FACTR1*DCOS(ARGC1)
      FCLI=FACTR*DSIN(ARGC)+FACTR1*DSIN(ARGC1)
      END IF
      FCL=DCMPLX(FCLR,FCLI)
      CALL FRUTH(FCNR,FCNI,FCFR,FCFI)
      CALL PQL(X,LMI,LMA) 
      LL=LMI
      FTT=0.0
      FNR=0.0
      FFR=0.0
   4  IF(LL.GT.LMA) GO TO 5
      PL=PLG(LL)
      QL=QLG(LL)
      QMINU=DCMPLX(0.5*PL,1.0D0/PI*QL)  
      QPLUS=DCMPLX(0.5*PL,-1.0D0/PI*QL)  
      FACTL=DCMPLX(DFLOAT(2*LL-1),0.0D0)
      FACTL=FACTL*COUL(LL)*(SMTR(LL)-DCMPLX(1.0D0,0.0D0))
      FTT=FTT+FACTL*DCMPLX(PL,0.0D0)/DCMPLX(0.0D0,2.0D0*SK)
      FNR=FNR+FACTL*QMINU/DCMPLX(0.0D0,2.0D0*SK)
      FFR=FFR+FACTL*QPLUS/DCMPLX(0.0D0,2.0D0*SK)
      LL=LL+LSTP
      GO TO 4
   5  FACTL=DCMPLX(DFLOAT(LSTP),0.0D0)
      FTT=FACTL*FTT+FCL
      SIGC=10.0D0*CDABS(FCL)**2
      SIGT=10.0D0*CDABS(FTT)**2/SIGC
C----For a symmetric system (12C+12C etc.) the near-far decomposition
C----should be performed for 'unsymmetric' cross section only, i.e. 
C----PTOLEMY output with LSTP=1. See also Fuller, P.R. C12 (1975) 1561.
      IF(LSTP.EQ.1) THEN
      FNR=FACTL*FNR+DCMPLX(FCNR,FCNI)
      FFR=FACTL*FFR+DCMPLX(FCFR,FCFI)
      SIGN=10.0D0*CDABS(FNR)**2/SIGC
      SIGF=10.0D0*CDABS(FFR)**2/SIGC
      SIGNC=10.0D0*((FCNR)**2+(FCNI)**2)/SIGC
      SIGFC=10.0D0*((FCFR)**2+(FCFI)**2)/SIGC
      ELSE
      SIGN=0.0
      SIGF=0.0
      SIGNC=0.0     
      SIGFC=0.0
      END IF
      WRITE(6,40)THETA,SIGT,SIGN,SIGF,SIGC,SIGNC,SIGFC
  40  FORMAT(F10.2,6G15.6)
   3  CONTINUE
      SIGMAR=SIGMAR*10.0D0*DFLOAT(LSTP)*PI/SK**2
      WRITE(6,50)
  50  FORMAT(/,3X,' THETA',3X,' SIGT./RUTH.',4X,'SIGN./RUTH.',
     *4X,'SIGF./RUTH.',4X,'RUTH. [mb]',4X,'SIGNC./RUTH.',4X,
     *'SIGFC./RUTH.'/)
      DO 6 L=LMI+1,LMA,LSTP
      DEFLN=DELTA(L)-DELTA(L-1)
      DLH=DFLOAT(L)-0.5D0
      DEFLC=2.0D0*DATAND(ETA/DLH)
      if(defln.gt.0.0)defln=defln-360.0
      DEFLS=DEFLN+DEFLC
      DRK=DLH/SK
   6  WRITE(6,60) L-1,DRK,SABS(L),DEFLS,DEFLN,DEFLC
  60  FORMAT(3X,I3,5G16.8)
      WRITE(6,70)
  70  FORMAT(/,3X,' L',5X,' D [fm]',8X,' |S(L)|',
     *8X,' DEFS.[deg]',6X,' DEFN.[deg]',4X,' DEFC.[deg]'/)
      WRITE(6,80) ETA,SIGMAR
  80  FORMAT(/,3X,' ETA =',F10.6,3X,' REACTION SIGMA [mb]=',
     *F10.3,/,/,3X,' NFDEC results obtained by using PTOLEMY 
     *output.'/,3X,' With best regards from Dao T. Khoa !!!' )
      END
C---------------------------------------------------------------------------
      SUBROUTINE FRUTH(FNR,FNI,FFR,FFI)
      IMPLICIT REAL*8 (A-H,O-Z)   
      COMPLEX*16 BB,CZ,A,B,ARG,PSI,S,TERM,AMPN,AMPF,AMPT
      COMMON/HELP1/ETA,PI,SIGMA0,SK,AN,FCLR,FCLI 
C----Near-Far decomposition of the Rutherford amplitude using Eqs.(14) and
C----(15) from R.C. Fuller, Phys. Rev. C12 (1975) 1563---------------------
C      CALL LIB$FLT_UNDER(0)
      G=0.577215664901532860606512D0
      CONVG=1.0D-9
      Z=DSIN(0.5D0*AN)**2 
      CZ=DCMPLX(Z,0.0D0)
      IF(ETA.EQ.0.0D0) THEN
      AMPN=-EXP(2.*DCMPLX(0.0,1.0)*SIGMA0)/(4.*SK*PI*Z)
      AMPF=-AMPN
      ELSE
C
      BB = DCMPLX(1.D0,ETA)	
      IF(Z.GT.0.5D0) GOTO 100
      S=1.0/BB
      N=1
  20  TERM=CZ**N/(BB+FLOAT(N))
      S=S+TERM
      N=N+1
      IF(CDABS(TERM)/CDABS(S).GT.CONVG) GO TO 20
      GOTO 300
 100  Z =1.0D0-Z
      CZ=DCMPLX(Z,0.0D0)
      A=1.0
C----START BY EVALUATING PSI( 30 + i ETA)---------------------------
      ARG=DCMPLX(30.D0,ETA)
C----USING ASYMPTOTIC FORM A&S 6.3.18-------------------------------
      PSI=CDLOG(ARG)-0.5/ARG-1.0/12.0/(ARG**2)+
     & 1.0/120.0/(ARG**4)-1.0/252.0/(ARG**6)
C----NOW BRING IT BACK TO PSI( 1 + i ETA)---------------------------
      DO 110 I=1,29		
      DFI=DFLOAT(I)
 110  PSI=PSI-1.0/DCMPLX(DFI,ETA)
      B=-CDLOG(CZ)-PSI-DCMPLX(G,0.0D0)
      S=A*B			
      N=1
 120  DFN=DFLOAT(N)
      A=A*DCMPLX(DFN,ETA)/FLOAT(N)
      B=B+DCMPLX(0.D0,ETA)/FLOAT(N)/DCMPLX(DFN,ETA)
      TERM=A*B*(CZ**N)
      S=S+TERM
      N=N+1
      IF(CDABS(TERM)/CDABS(S).GT.CONVG) GO TO 120
      Z=1.0-Z
      CZ=DCMPLX(Z,0.0D0)
 300  S=DCMPLX(0.D0,0.5/PI)*(CZ**DCMPLX(1.D0,ETA))*S
      XKT=DEXP(-2.0D0*PI*ETA)
      XKTN=1.0D0/(1.0D0-XKT)
      XKTF=-XKT/(1.0D0-XKT)
C----THE NEAR AMPLITUDE--------------------------------------------
      AMPN=DCMPLX(XKTN,0.0D0)-S
C----THE FAR AMPLITUDE--------------------------------------------
      AMPF=DCMPLX(XKTF,0.0D0)+S
      AMPT=DCMPLX(FCLR,FCLI)
      AMPN=AMPN*AMPT
      AMPF=AMPF*AMPT
      END IF
C
      FNR=DREAL(AMPN)
      FFR=DREAL(AMPF)
      FNI=DIMAG(AMPN)
      FFI=DIMAG(AMPF)
      RETURN
      END
C--------------------------------------------------------------
      FUNCTION SIGMAL(ETA,L)
      IMPLICIT REAL*8 (A-H,O-Z)   
C---USING FORM. 6.1.27 AND 6.3.2 FROM ABRAMOWITZ & STEGUN
      GAMMA=0.577215664901532860606512D0
      CONVG=1.0D-9
      IF(L.EQ.0) THEN 
      SIG0=-ETA*GAMMA
      ELSE
      SK=0.0D0      
      DO 1 K=1,L
   1  SK=SK+1.0D0/DFLOAT(K)
      SIG0=ETA*(-GAMMA+SK)
      END IF
      N=0
      SN=0.0D0
   2  FACTN=1.0D0+DFLOAT(L+N)
      TERM=ETA/FACTN-DATAN(ETA/FACTN)
      SN=SN+TERM
      N=N+1
      IF(DABS(TERM)/DABS(SN).GT.CONVG) GO TO 2
      SIGMAL=SIG0+SN
      RETURN
      END
C-------------------------------------------------------------
      SUBROUTINE PQL(X,LMI,LMA) 
      IMPLICIT REAL*8 (A-H,O-Z)   
      COMMON/HELP/PLG(500),QLG(500)
C---X=COS(THETA), 0 < THETA < PI-----------------------------
C---LMI MUST BE EITHER 1 OR AN INTEGER > 3--------------------
      PL0=1.0D0
      PL1=X 
      QL0=0.5D0*DLOG((1.0D0+X)/(1.0D0-X))
      QL1=X*QL0-1.0D0 
      IF(LMI.EQ.1) THEN 
      PLG(1)=PL0 
      QLG(1)=QL0 
      PLG(2)=PL1 
      QLG(2)=QL1 
      L1=3
      GO TO 20
      ELSE 
      DO 10 L=3,LMI-1
      PPL=DFLOAT(2*L-3)*X*PL1-DFLOAT(L-2)*PL0
      QQL=DFLOAT(2*L-3)*X*QL1-DFLOAT(L-2)*QL0
      PP=PPL/DFLOAT(L-1)
      QQ=QQL/DFLOAT(L-1)
      PL0=PL1
      QL0=QL1
      PL1=PP
   10 QL1=QQ
      L1=LMI
      END IF
   20 DO 30 L=L1,LMA
      PPL=DFLOAT(2*L-3)*X*PL1-DFLOAT(L-2)*PL0
      QQL=DFLOAT(2*L-3)*X*QL1-DFLOAT(L-2)*QL0
      PP=PPL/DFLOAT(L-1)
      QQ=QQL/DFLOAT(L-1)
      PL0=PL1
      QL0=QL1
      PL1=PP
      QL1=QQ
      PLG(L)=PP
   30 QLG(L)=QQ
      RETURN
      END

      SUBROUTINE WAVSET ( IRET, ALONSW, FITSW )                         
C                                                                       
C     INITIALIZES THE COMPUTATION OF THE SCATTERING WAVE FUNCTIONS.     
C                                                                       
C     THIS IS THE FIRST PART OF THE OLD WAVEF.  IT CHECKS AND           
C     PRINTS THE INPUT AND STORES EVERYTHING FOR WAVPOT.                
C     ARRAYS ARE SET UP FOR THE POTENTIAL IN THE FORM TO BE USED        
C     BY WAVELJ.  IN ALL CASES EXCEPT FITS THESE ARRAYS ARE FILLED.     
C     POINTERS AND PARAMETERS ARE LEFT IN 2-ELEMENT                     
C     ARRAYS THAT ARE LABELED BY THE CHANNEL NUMBER ( ICHANW = 1, 2 ).  
C                                                                       
C     IRET - SET TO 0 IF AN ERROR IS DETECTED; 1 IF O.K.                
C     ALONSW - LOGICAL*4 - .TRUE. MEANS THIS IS A STAND ALONE CALC.     
C              .FALSE. MEANS IT IS PART OF A DWBA.                      
C     FITSW - .TRUE. IF CALLED FROM THE FITTER (FITEL)                  
C                                                                       
C     THE POTENTIALS ARE DEFINED AS:                                    
C                                                                       
C     REAL(V) = VC - V/(1+X)                                            
C               + (VSO+TAU*V) * 4*L.S * (1/R) * (D/DR) 1/(1+XSO)        
C               + TR, TL, TP TENSOR TERMS (IF JSP = 2)                  
C     IMAG(V) = -VI/(1+XI)                                              
C               + (VSOI+TAUI*VI) * 4*L.S * (1/R) * (D/DR) 1/(1+XSOI)    
C               + VSI * 4*ASI * (D/DR) 1/(1+XSI)                        
C               + TR, TL, TP TENSOR TERMS (IF JSP = 2)                  
C     WHERE                                                             
C                                                                       
C     X = EXP( (RVAL-R)/A )                                             
C     XI = EXP( RVAL-RI)/AI ), ...,                                     
C     L.S = ( JP(JP+1) - SP(SP+1) - L(L+1) )/2                          
C     VC = ZP*ZT*HBARC/(ALPHA*RVAL)         RVAL > RC                   
C          ZP*ZT*HBARC/(2*ALPHA*RC) * (3 - (RVAL/RC)**2)  RVAL < RC     
C     ALPHA = FINE STRUCTURE CONSTANT.                                  
C                                                                       
C     THE COMPUTED WAVEFUNCTIONS ARE SOLUTIONS OF THE SCHROEDINGER      
C     EQUATION                                                          
C                                                                       
C       ( 1/(2M) * ( -(D/DR)**2 + L(L+1)/R**2 ) + V - E ) U(R) = 0      
C                                                                       
C     AND ARE NORMALIZED SUCH THAT                                      
C                                                                       
C       U(R) ---> (1/2) * ( (1+S)*F(KR) + I*(1-S)*G(KR) )               
C                                                                       
C     WHERE F(KR) AND G(KR) ARE THE REGULAR AND IRREGULAR COULOMB       
C     FUNCTIONS AND S IS THE S-MATRIX.                                  
C                                                                       
C     2/4/75 - MASSIVE RUPTURE OF WAVEF - S. P.                         
C     2/10/75 - COMPUTE COULOMB PHASE SHIFTS FOR INELDC                 
C     2/24/75 - INTEGRATE TO SEVERAL STEPS PAST LARGEST R NEEDED        
C     2/25/75 - LOTS OF INPUT CHECKS; DON'T DIVIDE BY 0 DIFUSNESS       
C     4/16/75 - NEW COMMON BLOCKS; REMOVE S.O. SINCE IT IS WRONG        
C     4/20/75 - SPLIT INTO WAVSET AND WAVPOT.                           
C     5/22/75 - ALONSW ADDED; VSI ADDED                                 
C     6/10/75 - FIX ERROR IN VSI CONSTANT                               
C     6/27/75 - STEPSPER; NEW RC UNDEF CHECK                            
C     8/3/75 - ETAS INTO KANDM COMMON.                                  
C     10/7/75 - POTENTIALS IN MAKPOT; PRINT R0'S - S.P.                 
C     10/10/75 - PROCESS ENERGY DEPENDANCE IN A, AI, V, VI.             
C     10/20/75 - ESQ PARAMETERS                                         
C     1/31/76 - NEW PWAVSW SETTING                                      
C     2/15/76 - ADD PWBGSW                                              
C     4/30/76 - MODIFIED COULOMB INPUT(MHM)                             
C     8/1/76 - 1/ELAB EXPANSION                                         
C     4/25/77 - IDENTICAL PARTICLES, FITSW                              
C     10/16/77 - POWERS OF WOODS-SAXONS                                 
C     11/20/77 - NEW ASYMPTOPIA; STORE POTENTIAL DEPTHS WITHOUT 1/E;    
C                NOLONGER USE A IN STEPSPER; PIECES OF WAVPOT HERE NOW. 
C     11/25/77 - LINKULES                                               
C     12/1/77 - LCRITL NOW CALLED HERE - S.P.                           
C     12/4/77 - SAVE LINKULE STUFF FOR DWBA IN LOCFIT - S.P.            
C     2/10/78 - LINKULES FOR WAVEFUNCTIONS - S.P.                       
C     5/5/78 - CENTRIFIGAL BARRIER IN AN ARRAY - S.P.                   
C     5/21/78 - NEW WAVELJ STRUCTURES - S.P.                            
C     12/11/78 - ADD TENSOR POTENTIALS - RPG                            
C     2/19/79 - REDUCE VARIABLE ASYMPTOPIA - RPG                        
C     3/18/79 - SAVE ALL OF /LNKBLK/ IN LNKAD2 - S.P.                   
C     5/4/79 - RATMAS CHANGES; DEFINE RC0P FOR PRINT - S.P.             
C     9/12/79 - STANDARD PREFIXES ETC; DELETE NUMJS DEFINITION          
C        (NOW IN WAVPOT) - RPG                                          
C     1/18/80 - DON'T CHANGE ASYMP & STEPSIZE FOR C.C. - S.P.           
C     4/23/80 - USE PWBGSW INSTEAD OF PBUGSW - S.P.                     
C     6/3/80 - SET LMIN=0 WHEN LCRITL=0, CHANGE PARPRT - S.P.           
C     7/16/80 - REMOVE LOGICAL SOSWT - S.P.                             
C     7/22/80 - FOR NEW CRAY VERSION USE 3*NPTS WORK ARRAYS -SP         
C     7/29/81 - SET LX=0 FOR DEFORMED POTENTIALAS -S.P.                 
C     10/18/81 - SET LX=-1 AS FLAG FOR DEFORMED POTS - S.P.             
C                                                                       
      IMPLICIT REAL*8 ( A-H, O-Z )                                      
      INTEGER*4 Z                                                       
      COMMON /LOCKT/ Z(100)                                               
      INTEGER FACFR4, FACFR2, FACFR1                                    
      COMMON /ALLOCS/ FACFR4, FACFR2, FACFR1                            
      DIMENSION ALLOC(1)                                                
      LOGICAL*1 MLLOC(1)                                                
      REAL*4 ALLOC4(1)                                                  
      INTEGER ILLOC(1)                                                  
      INTEGER*2 ILLOC2(1)                                               
      EQUIVALENCE (FACFR4,ALLOC(1),ILLOC(1),ILLOC2(1),ALLOC4(1),
     * MLLOC(1))
      COMMON /FLOAT/ A, ACCURA, AI, ANGSTP, ANGMIN, ANGMAX, ASO, ASOI, A
     *SYMPT, DELTVK, DWCUT, E, ECM, ELAB, EXS(5), GAMDIF, GAMSUM, TAU, T
     *AUI, AM, AMA, AMB, AMBIGA, AMBIGB, AMX, AMXCS(5), AMXCGS(5), AMP, 
     *AMT, Q, R, R0, RC, RC0, RI, RI0, RSO, RSO0, RSOI, RSOI0, SPAM, SPA
     *MP, SPAMT, STEPSZ, STEP1R, STEP1I, SUMMAX, SUMMID, SUMMIN, V, VI, 
     *VSO, VSOI, FITMUL, WRITES, ASI, RSI, RSI0, VSI, AMDMLT, STPSPR, R0
     *E, RI0E, AE, AIE, VE, VIE, FITACC, ALMNMT, SPFACP, SPFACT, R0ESQ, 
     *RI0ESQ, AESQ, AIESQ, VESQ, VIESQ, DERIVS, FITRAT, RCP, RCT, RC0P, 
     *RC0T, SUMPTS, ACCINE, COULML, ALMXMT, EXSPT(2), POWRL, POWIM, BNDA
     *SY, SCTASY, VTR,VTRI,VTL,VTLI,VTP,VTPI, PARAM1, PARAM2, PARAM3, PA
     *RAM4, PARAM5, PAR620(15), RTR, RTRI, RTL, RTLI, RTP, RTPI, RTR0, R
     *TRI0, RTL0, RTLI0, RTP0, RTPI0, ATR, ATRI, ATL, ATLI, ATP, ATPI, A
     *MXGPT(2), PHIMID, GAMPHI                                          
      DIMENSION PARAMS(20)                                              
      EQUIVALENCE ( PARAMS(1), PARAM1 )                                 
      DIMENSION AMS(5)                                                  
      EQUIVALENCE ( AMS(1), AMA )                                       
      DIMENSION VTEN(6), RTEN(6), RTEN0(6), ATEN(6)                     
      EQUIVALENCE ( VTEN(1), VTR ), (RTEN(1), RTR ), (RTEN0(1), RTR0 ), 
     *(ATEN(1), ATR )                                                   
      INTEGER PARITS, PARIPT, PARITY                                    
      COMMON /INTGER/ L, LMAX, LMIN, LOOKST, LX, MAPSUM, MAPDIF, MAXITR,
     * NAITKN, NBACK, NCOSIN, NODES, NPDIF, NPHIAD, NPPHI, NPSUM, IPRINT
     *, ISIZE, IZS(5), IZP, IZT, LSTEP, LBACK, MAXLEX, LMAXAD, MAXFUN, I
     *REINI, MODEFT, NUMRAN, NVPOLY, NPCOUL, MXCOUL, LMINSB, PARITS(5), 
     *PARIPT(2), PARITY, IPARM1, IPARM2, IPARM3, IPARM4, IPARM5, NBLKSZ,
     * MAPPHI, NFIROF, LEBACK                                           
      COMMON /JBLOCK/ J, JS(5), JP, JSP, JST, JPARM1, JPARM2, JPARM3    
      INTEGER PROBLM, R0TYPE, CONVRG                                    
      COMMON /SWITCH/ IASYMP, ICHECK, IECHO, IELAST, IFIT, IVRTEX, IRLWA
     *V, ITSO, LINEAR, NUCONL, NEXT, IFITER, IEPOW, ISAVMX, ISAVB, LABAN
     *G, PROBLM, MASTYP, R0TYPE, IBSPAS, ISW1, ISW2, ISW3, ISCRFL, NOBFA
     *C, CONVRG, IEXTYP, IBRNSB, MEORD, KFRMTP, IWRTWV, LORNTZ, IRELPT, 
     *ISAVSM                                                            
      LOGICAL*1 WASSET                                                  
      COMMON /INTRNL/ UNDEF, NOTDEF, ICHANB, ICHANW, ICNTT, EBNDS(2), ID
     *ONE, ISTRIP, IHSAVE, NEXTSV, IPOT, IWFN, LIMOST, IEXCIT, R0MASS, W
     *ASSET(40), RATMAS, LSPECS(4), NODESP(4), LSPCPT(2), NODEPT(2),ICD3
     *I                                                                 
      LOGICAL PWAVSW, STANSW, SOSWS, PWBGSW, TCSWS, SOSWT               
      COMMON /WAVCOM/ HS(2), RSTEPS(2), NSTPSS(2), NFS(2), NGS(2), NF1S(
     *2), NG1S(2), STEPR, STEPI, IWAVR, IWAVI, NUMAIT, NUMFIT, IOFFIT, P
     *WAVSW, NBAKCM, STANSW, SOSWS(2), NUMJS(2), RIS(2), AIS(2), RSOS(2)
     *, ASOS(2), RSOIS(2), ASOIS(2), IRLVS(2), IIMVS(2), IZPS(2), IZTS(2
     *), ASYMPS(2), V0RS(2), V0IS(2), V0SORS(2), V0SOIS(2), ES(2), JSPS(
     *2), RSIS(2), ASIS(2), V0SIS(2), ISORS(2), ISOIS(2), ALPHAR, ALPHAI
     *, NFIRST, PWBGSW, LASTL(2), LASTNF(2), LSKIPS(2), ISTATS(2), POWRL
     *S(2), POWIMS(2), NSTP2S(2), XFACS(3,2), IVWORK, ICENTR(2), TCSWS(2
     *), NWAVEF, VTENS(2,6), RTENS(2,6), ATENS(2,6), ITENS(2,6), IWAVRS(
     *2), IWAVIS(2), LASTZR, SOSWT, IINDXE(2), ITOCE(2)                 
      COMMON /LNKBLK/ NUMLNK, IUNIQU, LNKADR(6,12)                      
      REAL*8 LNKNAM(3,12)                                               
      EQUIVALENCE ( LNKNAM(1,1), LNKADR(1,1) )                          
      COMMON /KANDM/ AKI, AKO, REDMI, REDMO, RIMAX, ROMAX, ISIGS(2), RSC
     *TS(2), ASCTS(2), RCSCTS(2) ,ISMATS(2), LOMOST, LCRIT, ISCTMN, ISCT
     *CR, ETAS(2), RCSCTP(2), RCSCTT(2), LCRITS(2), RATMSS(2)           
      DIMENSION AKS(2), REDMS(2), RMAXS(2)                              
      EQUIVALENCE ( AKI, AKS(1) ), ( REDMI, REDMS(1) ), ( RIMAX, RMAXS(1
     *) )                                                               
      COMMON / TEMPVS / TVR, TVI, TVSOR, TVSOI, TAR, TAI                
      COMMON /CNSTNT/ PI, RT4PI, PIINV, RADIAN, DEGREE, HBARC, AMUMEV, A
     *FINE, BIGEST, SMLEST, BIGNUM, SMLNUM, BIGLOG                      
      REAL*4 TBEGIN, TIMES                                              
      COMMON /FTIME/ TBEGIN, NUMLOP, NUMWAV, TIMES(6), NUMCAL, NUMGRA   
      COMMON /LOCFIT/ LNKAD2(6,2,12)                                    
C                                                                       
      LOGICAL ALONSW, FITSW                                             
      CHARACTER*8 CHANAM(2), STATWD(2), SOTNAM(2), NAMES(2,11)          
      CHARACTER*4 TENNAM(6)
      CHARACTER*1 LINKID(4)
C 
      DATA CHANAM / 'INCOMING', 'OUTGOING' /                            
      DATA STATWD / 'BOSONS', 'FERMIONS' /                              
      DATA SOTNAM / 'SPIN-ORB', 'TENSOR' /                              
      DATA TENNAM / 'TR', 'TRI', 'TL', 'TLI', 'TP', 'TPI' /             
      DATA NAMES /'REALVA','REALVB','IMAGVA', 'IMAGVB','REALVSOA',
     *'REALVSOB','IMAGVSOA', 'IMAGVSOB' , 'CENTRIFA', 'CENTRIFB' , 
     *'REALVTRA','REALVTRB','IMAGVTRA','IMAGVTRB','REALVTLA', 
     *'REALVTLB','IMAGVTLA','IMAGVTLB',  'REALVTPA', 'REALVTPB',  
     *'IMAGVTPA', 'IMAGVTPB' /
c      DATA (NAMES(1,ik),ik=1,11)/'REALVA','IMAGVA','REALVSOA',
c     *'IMAGVSOA','CENTRIFA','REALVTRA','IMAGVTRA','REALVTLA', 
c     *'IMAGVTLA','REALVTPA','IMAGVTPA'/
c      DATA (NAMES(2,ik),ik=1,11)/'REALVB','IMAGVB','REALVSOB',
c     *'IMAGVSOB','CENTRIFB','REALVTRB','IMAGVTRB','REALVTLB', 
c     *'IMAGVTLB','REALVTPB','IMAGVTPB'/
C                                                                       
      DATA LINKID / '*', '1', '0', '0' /                                
C                                                                       
      LOGICAL SOSW, SOISW, IMAGSW, TENSW                                
C                                                                       
      IPRNT = 0                                                         
      IF ( FITSW ) GO TO 10                                             
      NUMFIT = 0                                                        
      IOFFIT = 1                                                        
      IPRNT = MOD( IPRINT, 10 )                                         
 10   PWAVSW = MOD(IPRINT/1000, 10) .GE. 1                              
      PWBGSW = MOD(IPRINT/1000, 10) .GE. 4                              
C                                                                       
      STANSW = ALONSW                                                   
C                                                                       
C     SOME OF THE PARAMETERS CAN HAVE AN ENERGY DEPENDENCE WHICH        
C     IS EXPRESSED IN TERMS OF THE LABORATORY ENERGY                    
C                                                                       
      EELAB = (1+RATMAS)*E                                              
      EEMUL=EELAB                                                       
      IF(IEPOW.EQ.1) EEMUL=1/EELAB                                      
      TVR = V + VE*EEMUL + VESQ*EEMUL**2                                
      TVI = VI + VIE*EEMUL + VIESQ*EEMUL**2                             
      TAR = A + AE*EEMUL + AESQ*EEMUL**2                                
      TAI = AI + AIE*EEMUL + AIESQ*EEMUL**2                             
C                                                                       
C     IS THERE AN IMAGINARY PART FOR THE POTENTIAL                      
C                                                                       
      IMAGSW = TVI .NE. 0                                               
C                                                                       
C     IS THERE A SPIN-ORBIT POTENTIAL                                   
C                                                                       
      TVSOR = VSO + TAU*TVR                                             
      TVSOI = VSOI + TAUI*TVI                                           
      SOSW = TVSOR .NE. 0                                               
      SOISW = TVSOI .NE. 0                                              
      SOSWT = SOSW .OR. SOISW                                           
C                                                                       
C     IS THERE A TENSOR POTENTIAL?                                      
C                                                                       
      TCSWS(ICHANW) = VTR .NE. 0 .OR. VTRI .NE. 0 .OR. VTP .NE. 0 .OR. V
     *TPI .NE. 0                                                        
      TENSW = TCSWS(ICHANW) .OR. VTL .NE. 0 .OR. VTLI .NE. 0            
      SOSWS(ICHANW) = SOSWT .OR. TENSW                                  
C                                                                       
C     TEST THE INPUT AND RETURN  0  COMPLETION CODE IF BAD              
C                                                                       
      IRET = 1                                                          
      IF ( LNKADR(3,1) .NE. 0 ) GO TO 25                                
      IF ( R .GT. 0 .AND. TAR .GT. 0 ) GO TO 25                         
      WRITE(6,23) R, TAR                                                  
 23   FORMAT ('0**** R OR A HAS INVALID VALUE:', 2G15.5 )               
      IRET = 0                                                          
 25   IF ( .NOT. IMAGSW ) GO TO 30                                      
      IF ( LNKADR(3,2) .NE. 0 ) GO TO 30                                
      IF ( RI .GT. 0 .AND. TAI .GT. 0 ) GO TO 30                        
      WRITE(6,27) RI, TAI                                                 
 27   FORMAT ( '0**** RI OR AI HAS INVALID VALUE:', 2G15.5 )            
      IRET = 0                                                          
 30   IF ( .NOT. SOSW ) GO TO 34                                        
      IF ( LNKADR(3,3) .NE. 0 ) GO TO 34                                
      IF ( RSO .GT. 0 .AND. ASO .GT. 0 ) GO TO 34                       
      WRITE(6,31) RSO, ASO                                                
 31   FORMAT ( '0**** RSO OR ASO HAS INVALID VALUE:', 2G15.5 )          
      IRET = 0                                                          
C                                                                       
C     CHECK  SP  FOR EITHER REAL OR IMAG SPIN ORBIT.                    
C                                                                       
 34   IF ( JSP .NE. NOTDEF .OR. .NOT. SOSWS(ICHANW) ) GO TO 40          
      JSP = 1                                                           
      IF (TENSW) JSP = 2                                                
      WRITE(6,35) JSP, SOTNAM(JSP)                                        
 35   FORMAT ( '0**** WARNING:  SP WAS NOT DEFINED; ',  'IT IS ASSUMED T
     *O BE ', I1, '/2 FOR THE ', A8, ' FORCE.' )                        
 40   IF ( E .GT. 0 .AND. AM .GT. 0 )  GO TO 45                         
      WRITE(6,43) E, AM                                                   
 43   FORMAT ('0**** ENERGY OR M (REDUCED MASS) HAS INVALID',  ' VALUE:'
     *, 3G15.5 )                                                        
      IRET = 0                                                          
 45   IF ( AMP .NE. UNDEF .AND. AMT .NE. UNDEF ) GO TO 50               
      WRITE(6,47)
 47   FORMAT ( '0**** BOTH MP AND MT MUST BE DEFINED.' )                
      IRET = 0                                                          
 50   IF ( RC .LT. ASYMPT ) GO TO 60                                    
      WRITE(6,53) RC, ASYMPT                                              
 53   FORMAT ('0**** RC MUST BE LESS THAN ASYMPTOPIA:', 2G15.5 )        
      IRET = 0                                                          
 60   RCC = RC                                                          
      IF ( RC .EQ. UNDEF ) WASSET(9) = .TRUE.                           
      IF ( RC .EQ. UNDEF ) RCC = 1                                      
      IF ( IZP*IZT .EQ. 0 ) GO TO 70                                    
      IF ( RC .GT. 0 ) GO TO 70                                         
      WRITE(6,63) RC
 63   FORMAT ('0**** RC IS INVALID:', G15.5 )                           
      IRET = 0                                                          
  70  RC = RCC                                                          
      IF ( VSI .EQ. 0 ) GO TO 80                                        
      IF ( LNKADR(3,2) .NE. 0 ) GO TO 80                                
      IF ( RSI .GT. 0 .AND. ASI .GT. 0 ) GO TO 80                       
      WRITE(6,73) RSI, ASI                                                
 73   FORMAT ( '0**** RSI OR ASI IS INVALID:', 2G15.5 )                 
      IRET = 0                                                          
 80   IF ( .NOT. SOISW ) GO TO 90                                       
      IF ( LNKADR(3,4) .NE. 0 ) GO TO 90                                
      IF ( RSOI .GT. 0 .AND. ASOI .GT. 0 ) GO TO 90                     
      WRITE(6,83) RSOI, ASOI                                              
 83   FORMAT ( '0**** RSOI OR ASOI HAS INVALID VALUE:', 2G15.5 )        
C                                                                       
 90   IF ( .NOT. TENSW ) GO TO 100                                      
      IF (JSP .EQ. 2) GO TO 93                                          
      WRITE(6,91) JSP                                                     
 91   FORMAT ( '0**** SP MUST BE 1 FOR TENSOR POTENTIALS, SP =',  I8, '/
     *2' / ' **** TENSOR POTENTIALS ARE SET TO 0' )                     
      DO 92 I = 1, 6                                                    
      VTEN(I) = 0                                                       
 92   CONTINUE                                                          
      TENSW = .FALSE.                                                   
      TCSWS(ICHANW) = .FALSE.                                           
      SOSWS(ICHANW) = SOSWT                                             
 93   DO 95 I = 1, 6                                                    
      IF ( VTEN(I) .EQ. 0 ) GO TO 95                                    
      IF ( LNKADR(3,I+4) .NE. 0 ) GO TO 95                              
      IF ( RTEN(I) .GT. 0 .AND. ATEN(I) .GT. 0 ) GO TO 95               
      WRITE(6,94) TENNAM(I), TENNAM(I), RTEN(I), ATEN(I)                  
 94   FORMAT ( '0**** R', A3, ' OR A', A3, ' HAS INVALID VALUE:',  2G15.
     *5 )                                                               
      IRET = 0                                                          
 95   CONTINUE                                                          
 100  IF ( IRET .EQ. 0 ) RETURN                                         
C                                                                       
      NBAKCM = NBACK                                                    
C                                                                       
C  SOME DERIVED DATA                                                    
C                                                                       
C  K VALUE                                                              
C                                                                       
      UK=DSQRT(2*AM*E)/HBARC                                            
      ALAMBD = 2*PI/UK                                                  
C                                                                       
C  COULOMB PARAMETER AND SIMPLE TERMS USING IT                          
C     INITIALIZE THE COULOMB POTENTIAL                                  
C                                                                       
      ETA=(IZP*IZT)*DSQRT(AM/(2.D0*E))/AFINE
      CALL SETVSQ(RCT,RCP,IZT,IZP,ICHANW)     
C                                                                       
C     COUPLED CHANNELS REQUIRE THE SAME STEPSIZE IN ALL CHANNELS        
C                                                                       
      IF ( PROBLM .LT. 23 .OR. ICHANW .EQ. 1 ) GO TO 110                
      RMAX = ASYMPS(1)                                                  
      STEPSZ = RSTEPS(1)                                                
      GO TO 120                                                         
C                                                                       
 110  IF ( STPSPR .NE. UNDEF ) STEPSZ = DMIN1( ALAMBD, 1.D0 ) / STPSPR  
C                                                                       
      RMAX = ASYMPT                                                     
C                                                                       
C     ADJUST ASYMPTOPIA IF THERE WILL BE VERY LARGE L'S.                
C     MATCHING MUST BE AT OR OUTSIDE THE CLASSICAL TURNING POINT.       
C     HOWEVER, FITTER DOES NOT ALLOW VARIABLE ASYMPTOPIA RIGHT NOW      
C                                                                       
      IF ( NUMFIT .EQ. 0 .AND. LMAX .NE. NOTDEF ) RMAX = DMAX1( RMAX, ( 
     *ETA + DSQRT(ETA**2+LMAX*(LMAX+1)) )/UK )                          
C                                                                       
C     NOTE - NSTEP IS COMPUTED HERE SEPARATLY FOR EACH CHANNEL          
C     AND IS STORED IN /WAVCOM/.  IT NEED NOT BE RELATED TO THE         
C     "NSTEPS" USED IN THE BOUND STATE CALCULATION.  HOWEVER, IF        
C     ASYMPT AND STEPSZ  ARE THE SAME FOR THE ENTIRE JOB, THEN          
C        NSTEP = NSTEPS-1.                                              
C                                                                       
 120  NSTEP = RMAX/STEPSZ + .5                                          
      RMAX = NSTEP*STEPSZ                                               
      H=UK*STEPSZ                                                       
C                                                                       
C     TEST FOR IDENTICAL PARTICLES                                      
C                                                                       
      LSKIP = 1                                                         
      ISTAT = 3                                                         
      IF ( IZP .NE. IZT .OR. AMP .NE. AMT .OR. JSP .NE. JST .OR. EXSPT(1
     *) .NE. EXSPT(2) ) GO TO 150                                       
      IF ( JSP .NE. NOTDEF ) GO TO 135                                  
      WRITE(6,133)
 133  FORMAT ( '0*** WARNING:  THE PARTICLES APPEAR TO BE IDENTICAL',  '
     * BUT THEIR SPINS HAVE NOT BEEN DEFINED;' /  15X, 'NON-IDENTICAL PA
     *RTICLE SCATTERING WILL BE ASSUMED.' )                             
      GO TO 150                                                         
 135  IF ( JSP .EQ. 0 ) LSKIP = 2                                       
      ISTAT = IAND(JSP,1) + 1                                           
C                                                                       
C     SAVE THINGS FOR WAVPOT AND WAVELJ                                 
C                                                                       
 150  HS(ICHANW)=H                                                      
      V0RS(ICHANW) =TVR                                                 
      V0IS(ICHANW) =TVI                                                 
      V0SORS(ICHANW) = TVSOR                                            
      V0SOIS(ICHANW) = TVSOI                                            
      V0SIS(ICHANW) = VSI                                               
      RSCTS(ICHANW) = R                                                 
      ASCTS(ICHANW) = TAR                                               
      RCSCTS(ICHANW) = RC                                               
      RCSCTP(ICHANW) = RCP                                              
      RCSCTT(ICHANW) = RCT                                              
      RIS(ICHANW) = RI                                                  
      AIS(ICHANW) = TAI                                                 
      RSOS(ICHANW) = RSO                                                
      ASOS(ICHANW) = ASO                                                
      RSOIS(ICHANW) = RSOI                                              
      ASOIS(ICHANW) = ASOI                                              
      RSIS(ICHANW) = RSI                                                
      ASIS(ICHANW) = ASI                                                
      DO 159 I = 1, 6                                                   
      VTENS(ICHANW,I) = VTEN(I)                                         
      RTENS(ICHANW,I) = RTEN(I)                                         
      ATENS(ICHANW,I) = ATEN(I)                                         
 159  CONTINUE                                                          
      ETAS(ICHANW) = ETA                                                
      IZPS(ICHANW) = IZP                                                
      IZTS(ICHANW) = IZT                                                
      ASYMPS(ICHANW) = RMAX                                             
      ES(ICHANW) = E                                                    
      RSTEPS(ICHANW) = STEPSZ                                           
      NSTPSS(ICHANW) = NSTEP                                            
      NSTP2S(ICHANW) = NSTEP                                            
      AKS(ICHANW) = UK                                                  
      REDMS(ICHANW) = AM                                                
      RATMSS(ICHANW) = RATMAS                                           
      JSPS(ICHANW) = JSP                                                
      STEPR = STEP1R                                                    
      STEPI = STEP1I                                                    
      NUMAIT = NAITKN                                                   
      NUMLOP = 0                                                        
      NUMWAV = 0                                                        
      LSKIPS(ICHANW) = LSKIP                                            
      ISTATS(ICHANW) = ISTAT                                            
      POWRLS(ICHANW) = POWRL                                            
      POWIMS(ICHANW) = POWIM                                            
      IWAVRS(ICHANW) = 0                                                
      IWAVIS(ICHANW) = 0                                                
C                                                                       
C     QUANTITIES FOR INTEGRATION PAST ASYMPTOPIA                        
C                                                                       
      XFACS(1,ICHANW) = 1 + H**2/12                                     
      XFACS(2,ICHANW) = - (H**2/12) * IZP*IZT*HBARC/(E*AFINE)           
      XFACS(3,ICHANW) = - (H**2/12) / UK**2                             
      TIMES(1) = 0                                                      
      TIMES(2) = 0                                                      
      TIMES(3) = 0                                                      
C                                                                       
C     INITIALIZE LINKULES IF NEEDED                                     
C                                                                       
      DO 259 I = 1, NUMLNK                                              
      IF ( LNKADR(3,I) .EQ. 0 ) GO TO 259                               
C                                                                       
C     GENERATE THE SPECIAL UNIQUE NAME                                  
C                                                                       
      IUNIQU = IUNIQU + 1                                               
      ENCODE ( 4, 233, LINKID ) IUNIQU                                  
 233  FORMAT ( 1H*, I3 )                                                
C                                                                       
C     MAKE INITIALIZING CALL                                            
C     
      CALL LINKUL ( LNKADR(3,I), LNKNAM(1,I), LNKADR(5,I), I, 1,  IRET, 
     *L, J, 0.D0, STEPSZ, NSTEP+1, DUMMY, DUMMY, LINKID )               
      IF ( IRET .GE. 0 ) GO TO 240                                      
      IRET = 0                                                          
      RETURN                                                            
 240  LNKADR(4,I) = IRET                                                
 259  CONTINUE                                                          
C                                                                       
      IF ( IPRNT .LT. 1 ) GO TO 600                                     
C                                                                       
C     PRINT OUT INPUT NICELY                                            
C                                                                       
 420  WRITE(6,423) CHANAM(ICHANW)                                         
 423  FORMAT ( / X, T10, 'OPTICAL MODEL SCATTERING FOR THE ',  A8, ' C
     *HANNEL' )                                                         
      WRITE(6,424) EELAB, E, UK, ALAMBD, AMP, AMT, AM                     
 424  FORMAT ( ' E LAB =', F9.3, ' MEV,    E CM =', F9.3,  ' MEV,     K 
     *=', G12.5, 5X, 'WAVELENGTH =', F8.4, ' FM' /  ' PROJECTILE MASS ='
     *, F7.2, ' AMU,', 5X,  'TARGET MASS =', F7.2, ' AMU,', 5X,  'REDUCE
     *D MASS =', F10.2, ' MEV/C**2' )                                   
      IF ( ISTAT .EQ. 3 ) WRITE(6,425)
 425  FORMAT ( ' THIS IS NON-IDENTICAL PARTICLE SCATTERING')            
      IF ( ISTAT .NE. 3 ) WRITE(6,426) STATWD(ISTAT)                      
 426  FORMAT ( ' THIS IS SCATTERING OF IDENTICAL ', A8 )                
      IF ( JSP .NE. NOTDEF .AND. JST .NE. NOTDEF )  WRITE(6,427)JSP,JST 
 427  FORMAT ( ' PROJECTILE SPIN =', I3, '/2', 5X, 'TARGET SPIN =',  I3,
     * '/2' )                                                           
      WRITE(6,429) IZP, IZT                                               
 429  FORMAT (' Z PROJECTILE =',I4, 5X,'Z TARGET =', I4 /' POTENTIAL', 
     *T20, 'COUPLING CONS.', T38, 'RADIUS',  T48, 'DIFFUSENESS', T63, 
     *'RADIUS PARAMETER' )                                            
C                                                                       
      IRET = 1                                                          
      CALL PARPRT ( 1, 'REAL CENTRAL       ', TVR, R, TAR,  R/R0MASS, PO
     *WRL, '   POWER', IRET )                                           
      CALL PARPRT ( 2, 'VOLUME ABSORPTION   ', TVI, RI, TAI,  RI/R0MASS,
     * POWIM, '   POWER   ', IRET )                                     
      CALL PARPRT ( 0, 'SURFACE ABSORPTION   ', VSI, RSI, ASI,  RSI/R0MA
     *SS, 0.D0, '        ', IRET )                                      
      CALL PARPRT ( 3, 'REAL SPIN-ORBIT   ', VSO, RSO, ASO,  RSO/R0MASS,
     * TAU, '     TAU', IRET )                                          
      CALL PARPRT ( 4, 'IMAG. SPIN-ORBIT   ', VSOI, RSOI, ASOI,  RSOI/R0
     *MASS, TAUI, '    TAUI', IRET )                                    
      CALL PARPRT ( 7, 'REAL TR      ', VTR, RTR, ATR,  RTR/R0MASS, 0.0D
     *0, '        ', IRET )                                             
      CALL PARPRT ( 8, 'IMAGINARY TR    ', VTRI, RTRI, ATRI,  RTRI/R0MAS
     *S, 0.0D0, '        ', IRET )                                      
      CALL PARPRT ( 9, 'REAL TL        ', VTL, RTL, ATL,  RTL/R0MASS, 0.
     *0D0, '        ', IRET )                                           
      CALL PARPRT ( 10, 'IMAG. TL        ', VTLI, RTLI, ATLI,  RTLI/R0MA
     *SS, 0.0D0, '        ', IRET )                                     
      CALL PARPRT ( 11, 'REAL TPR        ', VTP, RTP, ATP,  RTP/R0MASS, 
     *0.0D0, '        ', IRET )                                         
      CALL PARPRT ( 12, 'IMAG. TPR        ', VTPI, RTPI, ATPI,  RTPI/R0M
     *ASS, 0.0D0, '        ', IRET )                                    
      CALL PARPRT ( 5, 'PT&SPHERE  COULOMB', ETA, RC, 0.D0,  RC/R0MASS, 
     *0.0D0, '        ', IRET )                                         
      IF((RCP.EQ.0).OR.(RCT.EQ.0)) GO TO 500                            
      TEMP2 = RCP/AMP**0.33333333333333333333333 0D0                    
      TEMP3 = RCT/AMT**0.33333333333333333333333 0D0                    
      WRITE(6,187) RCP, RCT, TEMP2, TEMP3                                 
  187 FORMAT( ' FOLDED COULOMB POTENTIALS - RCP = ',F7.4,2X, 'RCT = ',F7
     *.4,2X,'RC0P = ',F7.4,2X,'RC0T = ',F7.4)                           
C                                                                       
 500  TEMP = DMIN1( ALAMBD, 1.D0 )/STEPSZ                               
      WRITE(6,503) RMAX, STEPSZ, TEMP                                     
  503 FORMAT(  ' ASYMPTOPIA =', T15, F8.3, ' FM' /  ' STEP SIZE =', T15,
     * F8.3, ' FM' ,  5X, F8.3, ' STEPS PER "WAVELENGTH"' / )           
C                                                                       
C     WILL THE WAVE FUNCTIONS BE FOUND BY A LINKULE                     
C                                                                       
      IF ( LNKADR(3,6) .EQ. 0 ) GO TO 600                               
      WRITE(6,533) LNKNAM(1,6)                                            
 533  FORMAT ( '  THE SCATTERING WAVEFUNCTION IS BEING',  ' COMPUTED BY 
     *THE ', A8, ' LINKULE:' )                                          
      I = 6                                                             
C                                                                       
C     CALL LINKULE TO PRINT STUFF ABOUT ITSELF                          
C                                                                       
 560  CALL LINKUL ( LNKADR(3,I), LNKNAM(1,I), LNKADR(5,I),  I, 2, IRTN, 
     * L, J, 0.D0, STEPSZ, NSTEP+1, DUMMY, DUMMY, ICHANW )              
      WRITE(6,563)
 563  FORMAT ( ' ' )                                                    
      IRET = MIN0(IRTN, IRET)                                           
      IF ( IRET .GE. 0 ) GO TO 600                                      
 570  IRET = 0                                                          
      RETURN                                                            
C                                                                       
C     SET ASIDE AREAS FOR THE POTENTIAL AND FOR V' USED BY WAVELJ       
C     THESE ARE STORED ONLY TO ASYMPTOPIA                               
C                                                                       
C     THIS IS DONE AS FOLLOWS:                                          
C                                                                       
C     1) FOR STAND-ALONE:  ON EVERY CALL TO WAVSET.                     
C     2) FOR ELASTIC FITS: MAXIMUM NUMBER OF STEPS IS ACCUMULATED IN    
C        NSTPSS(2); AS THE SIZE GROWS, THEY ARE ALLOCATED.              
C     3) FOR DWBA: POTENTIAL AREAS ARE ALLOCATED AT BOTH CALLS;         
C        WAVEFUNCTION AREAS ARE ALLOCATED ONLY ON 2ND CALL.             
C                                                                       
 600  NSTPP1 = NSTEP+1                                                  
C                                                                       
      IF ( NUMFIT .EQ. 0 ) GO TO 650                                    
      IF ( NSTPSS(2) .GE. NSTEP ) GO TO 680                             
      NSTPSS(2) = NSTEP                                                 
C                                                                       
 650  IVWORK = NALLOC( NSTPP1, 'VWORK' )                               
c      print 1919, nstpp1, names(ichanw,1)
c1919  format (x,I5,3x,A8)
      IRLVS(ICHANW) = NALLOC( NSTPP1, NAMES(ICHANW, 1) )                
      IIMVS(ICHANW) = NALLOC( NSTPP1+1, NAMES(ICHANW, 2) )              
      ICENTR(ICHANW) = NALLOC( NSTPP1, NAMES(ICHANW, 5) )               
      ISORS(ICHANW) = 0                                                 
      ISOIS(ICHANW) = 0                                                 
      IF ( V0SORS(ICHANW) .NE. 0 )  ISORS(ICHANW) = NALLOC( NSTPP1, NAME
     *S(ICHANW, 3) )                                                    
      IF ( V0SOIS(ICHANW) .NE. 0 )  ISOIS(ICHANW) = NALLOC( NSTPP1, NAME
     *S(ICHANW, 4) )                                                    
      DO 659 II = 1, 6                                                  
      ITENS(ICHANW,II) = 0                                              
      IF ( VTENS(ICHANW,II) .NE. 0 ) ITENS(ICHANW,II) =  NALLOC ( NSTPP1
     *, NAMES(ICHANW,II+5) )                                            
 659  CONTINUE                                                          
C                                                                       
C     AND COMPUTE THE POTENTIAL                                         
C     LX IS SET TO 0 FOR POSSIBLE USE BY DEFORMED POTENTIALS            
C                                                                       
 680  LXSAVE = LX                                                       
      LX = -1                                                           
      CALL MAKPOT ( ICHANW, IRET )                                      
      LX = LXSAVE                                                       
C                                                                       
C     FOR DWBA MUST SAVE TWO SETS OF LINKULE INDICATORS                 
C                                                                       
      IF ( NUMFIT .NE. 0 ) GO TO 690                                    
      DO 685 I = 1, NUMLNK                                              
      DO 685 II = 1, 6                                                  
      LNKAD2(II,ICHANW,I) = LNKADR(II,I)                                
 685  CONTINUE                                                          
C                                                                       
C     WORK AREA NOT NEEDED AFTER MAKPOT                                 
C                                                                       
 690  IF ( NUMFIT .EQ. 0 ) Z(IVWORK) = -Z(IVWORK)                       
C                                                                       
      IF ( IRET .GE. 0 ) GO TO 700                                      
      IRET = 0                                                          
      RETURN                                                            
C                                                                       
C     DETERMINE LCRITICAL.                                              
C     IF BOTH LMIN AND LMAX ARE DEFINED WE BYPASS THIS AND JUST USE     
C     THE AVERAGE.                                                      
C                                                                       
 700  IF ( LMIN .EQ. NOTDEF .OR. LMAX .EQ. NOTDEF ) GO TO 720           
      LCRITS(ICHANW) = (LMIN+LMAX)/2                                    
      GO TO 750                                                         
 720  CALL LCRITL ( E, UK, ETA, RC, NSTEP+1,  0.D0, STEPSZ, IRLVS(ICHANW
     *), IIMVS(ICHANW),  48, MOD(IPRINT/10, 10),  LC1, LC2, LCRITS(ICHAN
     *W) )                                                              
      IF ( IPRNT .NE. 0 ) WRITE(6,723) LCRITS(ICHANW), LC1, LC2           
 723  FORMAT ( ' ESTIMATED CRITICAL L:', I4 ,  5X, 'BY !S!:', I4, 5X, 'B
     *Y DEFLECTION FUNC.:', I4 )                                        
C                                                                       
C     IF LC1=0  THEN !S!=1 ALWAYS AND WE MUST FORCE LMIN=0.             
C                                                                       
      IF ( LC1 .EQ. 0 .AND. LMIN .EQ. NOTDEF ) LMIN = 0                 
C                                                                       
C     ON 2ND CALL ALLOCATE AREAS FOR THE WAVE FUNCTIONS USING LARGEST   
C     NSTEP.                                                            
C                                                                       
 750  IF ( .NOT. STANSW .AND. ICHANW .EQ. 1 ) GO TO 800                 
      IF ( .NOT. STANSW ) NSTPP1 = MAX0(NSTPSS(1)+1, NSTPP1)            
      I = NSTPP1+6                                                      
      NWAVEF = I                                                        
CCRA                                                                    
CCRA     ON CRAY WE DO SOME OF THE WORK IN VECTOR WORK ARRAYS           
CCRA                                                                    
CRA      I = 3*I                                                        
C     WE NEED ROOM FOR 4 WAVE FUNCTIONS IF TENSOR COUPLING IS PRESENT.  
      IF ( TCSWS(ICHANW) .OR. ( TCSWS(3-ICHANW) .AND. .NOT. STANSW ) )  
     *I = 4*I                                                           
      IWAVR = NALLOC( I, 'WAVER ' )                                     
      IWAVI = NALLOC( I, 'WAVEI ' )                                     
C                                                                       
 800  IRET = 1                                                          
      RETURN                                                            
      END                                                               
